# openapi-client
Sending and receiving messages using HTTP requests. Fixed price with no hidden fees, without limits and restrictions. You will be able to send and receive text/media/files/locations/goods/orders/polls messages via WhatsApp in private or group chats. Guides and SDK can be found on our website.

This Python package is automatically generated by the [OpenAPI Generator](https://openapi-generator.tech) project:

- API version: 1.8.7
- Package version: 1.0.0
- Generator version: 7.9.0
- Build package: org.openapitools.codegen.languages.PythonClientCodegen
For more information, please visit [https://whapi.cloud/support](https://whapi.cloud/support)

## Requirements.

Python 3.7+

## Installation & Usage
### pip install

If the python package is hosted on a repository, you can install directly using:

```sh
pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git
```
(you may need to run `pip` with root permission: `sudo pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git`)

Then import the package:
```python
import openapi_client
```

### Setuptools

Install via [Setuptools](http://pypi.python.org/pypi/setuptools).

```sh
python setup.py install --user
```
(or `sudo python setup.py install` to install the package for all users)

Then import the package:
```python
import openapi_client
```

### Tests

Execute `pytest` to run the tests.

## Getting Started

Please follow the [installation procedure](#installation--usage) and then run the following:

```python

import openapi_client
from openapi_client.rest import ApiException
from pprint import pprint

# Defining the host is optional and defaults to https://gate.whapi.cloud
# See configuration.py for a list of all supported configuration parameters.
configuration = openapi_client.Configuration(
    host = "https://gate.whapi.cloud"
)

# The client must configure the authentication and authorization parameters
# in accordance with the API server security policy.
# Examples for each auth method are provided below, use the example that
# satisfies your auth use case.

# Configure API key authorization: tokenAuth
configuration.api_key['tokenAuth'] = os.environ["API_KEY"]

# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['tokenAuth'] = 'Bearer'

# Configure Bearer authorization (token): bearerAuth
configuration = openapi_client.Configuration(
    access_token = os.environ["BEARER_TOKEN"]
)


# Enter a context with an instance of the API client
with openapi_client.ApiClient(configuration) as api_client:
    # Create an instance of the API class
    api_instance = openapi_client.BlacklistApi(api_client)
    contact_id = 'contact_id_example' # str | Contact ID

    try:
        # Add contact to blacklist
        api_response = api_instance.blacklist_add(contact_id)
        print("The response of BlacklistApi->blacklist_add:\n")
        pprint(api_response)
    except ApiException as e:
        print("Exception when calling BlacklistApi->blacklist_add: %s\n" % e)

```

## Documentation for API Endpoints

All URIs are relative to *https://gate.whapi.cloud*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*BlacklistApi* | [**blacklist_add**](docs/BlacklistApi.md#blacklist_add) | **PUT** /blacklist/{ContactID} | Add contact to blacklist
*BlacklistApi* | [**blacklist_remove**](docs/BlacklistApi.md#blacklist_remove) | **DELETE** /blacklist/{ContactID} | Remove contact from blacklist
*BusinessApi* | [**create_collection**](docs/BusinessApi.md#create_collection) | **POST** /business/collections | Create collection
*BusinessApi* | [**create_product**](docs/BusinessApi.md#create_product) | **POST** /business/products | Create product
*BusinessApi* | [**delete_collection**](docs/BusinessApi.md#delete_collection) | **DELETE** /business/collections/{CollectionID} | Delete collection
*BusinessApi* | [**delete_product**](docs/BusinessApi.md#delete_product) | **DELETE** /business/products/{ProductID} | Delete product
*BusinessApi* | [**edit_business_profile**](docs/BusinessApi.md#edit_business_profile) | **POST** /business | Edit your Business Profile
*BusinessApi* | [**edit_collection**](docs/BusinessApi.md#edit_collection) | **PATCH** /business/collections/{CollectionID} | Edit collection
*BusinessApi* | [**get_business_profile**](docs/BusinessApi.md#get_business_profile) | **GET** /business | Get business profile
*BusinessApi* | [**get_collection**](docs/BusinessApi.md#get_collection) | **GET** /business/collections/{CollectionID} | Get collection
*BusinessApi* | [**get_collections_list**](docs/BusinessApi.md#get_collections_list) | **GET** /business/collections | Get collections
*BusinessApi* | [**get_contact_products**](docs/BusinessApi.md#get_contact_products) | **GET** /business/{ContactID}/products | Get products by Contact ID
*BusinessApi* | [**get_order_items**](docs/BusinessApi.md#get_order_items) | **GET** /business/orders/{OrderID} | Get order items
*BusinessApi* | [**get_product**](docs/BusinessApi.md#get_product) | **GET** /business/products/{ProductID} | Get product
*BusinessApi* | [**get_products**](docs/BusinessApi.md#get_products) | **GET** /business/products | Get products
*BusinessApi* | [**send_catalog**](docs/BusinessApi.md#send_catalog) | **POST** /business/catalogs/{ContactID} | Send catalog by Contact ID (phone number)
*BusinessApi* | [**send_product**](docs/BusinessApi.md#send_product) | **POST** /business/products/{ProductID} | Send product
*BusinessApi* | [**update_product**](docs/BusinessApi.md#update_product) | **PATCH** /business/products/{ProductID} | Update product
*ChannelApi* | [**check_health**](docs/ChannelApi.md#check_health) | **GET** /health | Check health &amp; launch channel
*ChannelApi* | [**get_allowed_events**](docs/ChannelApi.md#get_allowed_events) | **GET** /settings/events | Get allowed events
*ChannelApi* | [**get_channel_settings**](docs/ChannelApi.md#get_channel_settings) | **GET** /settings | Get channel settings
*ChannelApi* | [**get_limits**](docs/ChannelApi.md#get_limits) | **GET** /limits | Get limits
*ChannelApi* | [**reset_channel_settings**](docs/ChannelApi.md#reset_channel_settings) | **DELETE** /settings | Reset channel settings
*ChannelApi* | [**update_channel_settings**](docs/ChannelApi.md#update_channel_settings) | **PATCH** /settings | Update channel settings
*ChannelApi* | [**webhook_test**](docs/ChannelApi.md#webhook_test) | **POST** /settings/webhook_test | Test webhook
*ChatsApi* | [**archive_chat**](docs/ChatsApi.md#archive_chat) | **POST** /chats/{ChatID} | 🗄 Archive/Unarchive chat
*ChatsApi* | [**delete_chat**](docs/ChatsApi.md#delete_chat) | **DELETE** /chats/{ChatID} | ❌ Delete chat
*ChatsApi* | [**get_chat**](docs/ChatsApi.md#get_chat) | **GET** /chats/{ChatID} | Get chat
*ChatsApi* | [**get_chats**](docs/ChatsApi.md#get_chats) | **GET** /chats | Get chats
*ChatsApi* | [**patch_chat**](docs/ChatsApi.md#patch_chat) | **PATCH** /chats/{ChatID} | 📌 Pin/Unpin chat or 🔇 Mute/Unmute chat or ✔✔ Mark as read/unread chat
*CommunitiesApi* | [**add_community_participant**](docs/CommunitiesApi.md#add_community_participant) | **POST** /communities/{CommunityID}/participants | Add participants to community
*CommunitiesApi* | [**change_community_settings**](docs/CommunitiesApi.md#change_community_settings) | **PATCH** /communities/{CommunityID}/settings | Change community settings
*CommunitiesApi* | [**create_community**](docs/CommunitiesApi.md#create_community) | **POST** /communities | Create community
*CommunitiesApi* | [**deactivate_community**](docs/CommunitiesApi.md#deactivate_community) | **DELETE** /communities/{CommunityID} | Deactivate community
*CommunitiesApi* | [**demote_community_participant**](docs/CommunitiesApi.md#demote_community_participant) | **DELETE** /communities/{CommunityID}/admins | Demote participants to admin in community
*CommunitiesApi* | [**get_communities**](docs/CommunitiesApi.md#get_communities) | **GET** /communities | Get communities
*CommunitiesApi* | [**get_community**](docs/CommunitiesApi.md#get_community) | **GET** /communities/{CommunityID} | Get community
*CommunitiesApi* | [**get_community_sub_groups**](docs/CommunitiesApi.md#get_community_sub_groups) | **GET** /communities/{CommunityID}/subGroups | Get community subgroups
*CommunitiesApi* | [**link_group_to_community**](docs/CommunitiesApi.md#link_group_to_community) | **PUT** /communities/{CommunityID}/{GroupID} | Link group to community
*CommunitiesApi* | [**promote_community_participant**](docs/CommunitiesApi.md#promote_community_participant) | **PATCH** /communities/{CommunityID}/admins | Promote participants to admin in community
*CommunitiesApi* | [**remove_community_participant**](docs/CommunitiesApi.md#remove_community_participant) | **DELETE** /communities/{CommunityID}/participants | Remove participants from community
*CommunitiesApi* | [**revoke_community_invite**](docs/CommunitiesApi.md#revoke_community_invite) | **DELETE** /communities/{CommunityID}/revokeInviteUrl | Revoke community invite
*CommunitiesApi* | [**unlink_group_from_community**](docs/CommunitiesApi.md#unlink_group_from_community) | **DELETE** /communities/{CommunityID}/{GroupID} | Unlink group from community
*ContactsApi* | [**check_phones**](docs/ContactsApi.md#check_phones) | **POST** /contacts | Check phones
*ContactsApi* | [**get_contact**](docs/ContactsApi.md#get_contact) | **GET** /contacts/{ContactID} | Get contact
*ContactsApi* | [**get_contact_profile**](docs/ContactsApi.md#get_contact_profile) | **GET** /contacts/{ContactID}/profile | Get profile
*ContactsApi* | [**get_contacts**](docs/ContactsApi.md#get_contacts) | **GET** /contacts | Get contacts
*ContactsApi* | [**send_contact**](docs/ContactsApi.md#send_contact) | **POST** /contacts/{ContactID} | Send contact
*GroupsApi* | [**accept_group_invite**](docs/GroupsApi.md#accept_group_invite) | **PUT** /groups | Accept group invite
*GroupsApi* | [**add_group_participant**](docs/GroupsApi.md#add_group_participant) | **POST** /groups/{GroupID}/participants | Add group participant
*GroupsApi* | [**approve_group_applications_list**](docs/GroupsApi.md#approve_group_applications_list) | **POST** /groups/{GroupID}/applications | Accept group applications for listed users
*GroupsApi* | [**create_group**](docs/GroupsApi.md#create_group) | **POST** /groups | Create group
*GroupsApi* | [**delete_group_icon**](docs/GroupsApi.md#delete_group_icon) | **DELETE** /groups/{GroupID}/icon | Delete group icon
*GroupsApi* | [**demote_group_admin**](docs/GroupsApi.md#demote_group_admin) | **DELETE** /groups/{GroupID}/admins | Demote group admin
*GroupsApi* | [**get_group**](docs/GroupsApi.md#get_group) | **GET** /groups/{GroupID} | Get group
*GroupsApi* | [**get_group_applications_list**](docs/GroupsApi.md#get_group_applications_list) | **GET** /groups/{GroupID}/applications | Get list of join requests to the group
*GroupsApi* | [**get_group_icon**](docs/GroupsApi.md#get_group_icon) | **GET** /groups/{GroupID}/icon | Get group icon
*GroupsApi* | [**get_group_invite**](docs/GroupsApi.md#get_group_invite) | **GET** /groups/{GroupID}/invite | Get group invite
*GroupsApi* | [**get_group_metadata_by_invite_code**](docs/GroupsApi.md#get_group_metadata_by_invite_code) | **GET** /groups/link/{InviteCode} | Get group info by invite code
*GroupsApi* | [**get_groups**](docs/GroupsApi.md#get_groups) | **GET** /groups | Get groups
*GroupsApi* | [**leave_group**](docs/GroupsApi.md#leave_group) | **DELETE** /groups/{GroupID} | Leave group
*GroupsApi* | [**promote_to_group_admin**](docs/GroupsApi.md#promote_to_group_admin) | **PATCH** /groups/{GroupID}/admins | Promote to group admin
*GroupsApi* | [**reject_group_applications_list**](docs/GroupsApi.md#reject_group_applications_list) | **DELETE** /groups/{GroupID}/applications | Reject group applications for listed users
*GroupsApi* | [**remove_group_participant**](docs/GroupsApi.md#remove_group_participant) | **DELETE** /groups/{GroupID}/participants | Remove group participant
*GroupsApi* | [**revoke_group_invite**](docs/GroupsApi.md#revoke_group_invite) | **DELETE** /groups/{GroupID}/invite | Revoke group invite
*GroupsApi* | [**send_group_invite**](docs/GroupsApi.md#send_group_invite) | **POST** /groups/link/{InviteCode} | Send group invite link
*GroupsApi* | [**set_group_icon**](docs/GroupsApi.md#set_group_icon) | **PUT** /groups/{GroupID}/icon | Set group icon
*GroupsApi* | [**update_group_info**](docs/GroupsApi.md#update_group_info) | **PUT** /groups/{GroupID} | Update group info
*GroupsApi* | [**update_group_setting**](docs/GroupsApi.md#update_group_setting) | **PATCH** /groups/{GroupID} | Update group setting
*LabelsApi* | [**add_label_association**](docs/LabelsApi.md#add_label_association) | **POST** /labels/{LabelID}/{AssociationID} | Add label association
*LabelsApi* | [**delete_label_association**](docs/LabelsApi.md#delete_label_association) | **DELETE** /labels/{LabelID}/{AssociationID} | Delete label association
*LabelsApi* | [**get_label_associations**](docs/LabelsApi.md#get_label_associations) | **GET** /labels/{LabelID} | Get objects associated with label
*LabelsApi* | [**get_labels**](docs/LabelsApi.md#get_labels) | **GET** /labels | Get labels
*MediaApi* | [**delete_media**](docs/MediaApi.md#delete_media) | **DELETE** /media/{MediaID} | Delete media
*MediaApi* | [**get_media**](docs/MediaApi.md#get_media) | **GET** /media/{MediaID} | Get media
*MediaApi* | [**get_media_files**](docs/MediaApi.md#get_media_files) | **GET** /media | Get media files
*MediaApi* | [**upload_media**](docs/MediaApi.md#upload_media) | **POST** /media | Upload media
*MessagesApi* | [**delete_message**](docs/MessagesApi.md#delete_message) | **DELETE** /messages/{MessageID} | ❌ Delete message
*MessagesApi* | [**forward_message**](docs/MessagesApi.md#forward_message) | **POST** /messages/{MessageID} | ↪ Forward message
*MessagesApi* | [**get_message**](docs/MessagesApi.md#get_message) | **GET** /messages/{MessageID} | Get message
*MessagesApi* | [**get_messages**](docs/MessagesApi.md#get_messages) | **GET** /messages/list | Get messages
*MessagesApi* | [**get_messages_by_chat_id**](docs/MessagesApi.md#get_messages_by_chat_id) | **GET** /messages/list/{ChatID} | Get messages by chat ID
*MessagesApi* | [**mark_message_as_read**](docs/MessagesApi.md#mark_message_as_read) | **PUT** /messages/{MessageID} | ✔✔ Mark message as read
*MessagesApi* | [**react_to_message**](docs/MessagesApi.md#react_to_message) | **PUT** /messages/{MessageID}/reaction | 😍 React to message
*MessagesApi* | [**send_media_message**](docs/MessagesApi.md#send_media_message) | **POST** /messages/media/{MediaMessageType} | 📎 Send media message
*MessagesApi* | [**send_message_audio**](docs/MessagesApi.md#send_message_audio) | **POST** /messages/audio | 🎵 Send media-audio message
*MessagesApi* | [**send_message_contact**](docs/MessagesApi.md#send_message_contact) | **POST** /messages/contact | 👤 Send contact message
*MessagesApi* | [**send_message_contact_list**](docs/MessagesApi.md#send_message_contact_list) | **POST** /messages/contact_list | 👥 Send contact list message
*MessagesApi* | [**send_message_document**](docs/MessagesApi.md#send_message_document) | **POST** /messages/document | 📑 Send media-document message
*MessagesApi* | [**send_message_gif**](docs/MessagesApi.md#send_message_gif) | **POST** /messages/gif | 🎬 Send media-gif message
*MessagesApi* | [**send_message_image**](docs/MessagesApi.md#send_message_image) | **POST** /messages/image | 🖼 Send media-image message
*MessagesApi* | [**send_message_interactive**](docs/MessagesApi.md#send_message_interactive) | **POST** /messages/interactive | 🎮 Send interactive message
*MessagesApi* | [**send_message_link_preview**](docs/MessagesApi.md#send_message_link_preview) | **POST** /messages/link_preview | 📎 Send link preview message
*MessagesApi* | [**send_message_live_location**](docs/MessagesApi.md#send_message_live_location) | **POST** /messages/live_location | 🧭 Send live location message
*MessagesApi* | [**send_message_location**](docs/MessagesApi.md#send_message_location) | **POST** /messages/location | 📍 Send location message
*MessagesApi* | [**send_message_poll**](docs/MessagesApi.md#send_message_poll) | **POST** /messages/poll | 📊 Send poll message
*MessagesApi* | [**send_message_short**](docs/MessagesApi.md#send_message_short) | **POST** /messages/short | 📹 Send media-short video message (PTV)
*MessagesApi* | [**send_message_sticker**](docs/MessagesApi.md#send_message_sticker) | **POST** /messages/sticker | 🎭 Send media-sticker message
*MessagesApi* | [**send_message_story**](docs/MessagesApi.md#send_message_story) | **POST** /messages/story | 👁️‍🗨️ Send story message
*MessagesApi* | [**send_message_story_audio**](docs/MessagesApi.md#send_message_story_audio) | **POST** /messages/story/audio | 🎵️ Send story audio message
*MessagesApi* | [**send_message_story_media**](docs/MessagesApi.md#send_message_story_media) | **POST** /messages/story/media | 🖼 Send story media message
*MessagesApi* | [**send_message_story_text**](docs/MessagesApi.md#send_message_story_text) | **POST** /messages/story/text | 💬 Send story text message
*MessagesApi* | [**send_message_text**](docs/MessagesApi.md#send_message_text) | **POST** /messages/text | 💬 Send text message
*MessagesApi* | [**send_message_video**](docs/MessagesApi.md#send_message_video) | **POST** /messages/video | 🎥 Send media-video message
*MessagesApi* | [**send_message_voice**](docs/MessagesApi.md#send_message_voice) | **POST** /messages/voice | 🎤 Send media-voice message
*MessagesApi* | [**star_message**](docs/MessagesApi.md#star_message) | **PUT** /messages/{MessageID}/star | ⭐ Star message
*NewslettersApi* | [**accept_newsletter_admin_request**](docs/NewslettersApi.md#accept_newsletter_admin_request) | **PUT** /newsletters/{NewsletterID}/admins/{ContactID} | Accept Newsletter admin-request
*NewslettersApi* | [**create_newsletter**](docs/NewslettersApi.md#create_newsletter) | **POST** /newsletters | Create newsletter
*NewslettersApi* | [**create_newsletter_admin_invite**](docs/NewslettersApi.md#create_newsletter_admin_invite) | **POST** /newsletters/{NewsletterID}/invite/{ContactID} | Create Newsletter admin-invite
*NewslettersApi* | [**delete_newsletter**](docs/NewslettersApi.md#delete_newsletter) | **DELETE** /newsletters/{NewsletterID} | Delete newsletter
*NewslettersApi* | [**demote_newsletter_admin**](docs/NewslettersApi.md#demote_newsletter_admin) | **DELETE** /newsletters/{NewsletterID}/admins/{ContactID} | Demote Newsletter admin
*NewslettersApi* | [**edit_newsletter**](docs/NewslettersApi.md#edit_newsletter) | **PATCH** /newsletters/{NewsletterID} | Edit newsletter
*NewslettersApi* | [**find_newsletter**](docs/NewslettersApi.md#find_newsletter) | **GET** /newsletters/find | Find newsletters by filters
*NewslettersApi* | [**get_messages_newsletter**](docs/NewslettersApi.md#get_messages_newsletter) | **GET** /newsletters/{NewsletterID}/messages | Get newsletter messages
*NewslettersApi* | [**get_newsletter**](docs/NewslettersApi.md#get_newsletter) | **GET** /newsletters/{NewsletterID} | Get newsletter information
*NewslettersApi* | [**get_newsletter_by_invite_code**](docs/NewslettersApi.md#get_newsletter_by_invite_code) | **GET** /newsletters/link/{NewsletterInviteCode} | Get newsletter info by invite code
*NewslettersApi* | [**get_newsletters**](docs/NewslettersApi.md#get_newsletters) | **GET** /newsletters | Get newsletters
*NewslettersApi* | [**recommended_newsletter**](docs/NewslettersApi.md#recommended_newsletter) | **GET** /newsletters/recommended | Get recommended newsletters by country
*NewslettersApi* | [**revoke_newsletter_admin_invite**](docs/NewslettersApi.md#revoke_newsletter_admin_invite) | **DELETE** /newsletters/{NewsletterID}/invite/{ContactID} | Revoke Newsletter admin-invite
*NewslettersApi* | [**send_newsletter_invite**](docs/NewslettersApi.md#send_newsletter_invite) | **POST** /newsletters/link/{NewsletterInviteCode} | Send newsletter invite link
*NewslettersApi* | [**subscribe_newsletter**](docs/NewslettersApi.md#subscribe_newsletter) | **POST** /newsletters/{NewsletterID}/subscription | Subscribe to newsletter
*NewslettersApi* | [**subscribe_newsletter_invite**](docs/NewslettersApi.md#subscribe_newsletter_invite) | **POST** /newsletters/invite/{NewsletterInviteCode}/subscription | Subscribe to newsletter by invite code
*NewslettersApi* | [**tracking_newsletter**](docs/NewslettersApi.md#tracking_newsletter) | **POST** /newsletters/{NewsletterID}/tracking | Subscribe to newsletter updates
*NewslettersApi* | [**unsubscribe_newsletter**](docs/NewslettersApi.md#unsubscribe_newsletter) | **DELETE** /newsletters/{NewsletterID}/subscription | Unsubscribe from newsletter
*NewslettersApi* | [**unsubscribe_newsletter_invite**](docs/NewslettersApi.md#unsubscribe_newsletter_invite) | **DELETE** /newsletters/invite/{NewsletterInviteCode}/subscription | Unsubscribe from newsletter by invite code
*PresencesApi* | [**get_presence**](docs/PresencesApi.md#get_presence) | **GET** /presences/{EntryID} | Get presence
*PresencesApi* | [**send_me_presence**](docs/PresencesApi.md#send_me_presence) | **PUT** /presences/me | Send online or offline presence
*PresencesApi* | [**send_presence**](docs/PresencesApi.md#send_presence) | **PUT** /presences/{EntryID} | Send typing or recording presence
*PresencesApi* | [**subscribe_presence**](docs/PresencesApi.md#subscribe_presence) | **POST** /presences/{EntryID} | Subscribe to presence
*StatusesApi* | [**get_message_view_statuses**](docs/StatusesApi.md#get_message_view_statuses) | **GET** /statuses/{MessageID} | Get message or story view statuses
*StoriesApi* | [**create_story**](docs/StoriesApi.md#create_story) | **POST** /stories | Create &amp; publish story
*StoriesApi* | [**create_story_audio**](docs/StoriesApi.md#create_story_audio) | **POST** /stories/send/audio | 🎵️ Post audio story
*StoriesApi* | [**create_story_media**](docs/StoriesApi.md#create_story_media) | **POST** /stories/send/media | 🖼 Post media story
*StoriesApi* | [**create_story_text**](docs/StoriesApi.md#create_story_text) | **POST** /stories/send/text | 💬 Post text story
*StoriesApi* | [**get_stories**](docs/StoriesApi.md#get_stories) | **GET** /stories | Get list of stories
*StoriesApi* | [**send_message_story_text_0**](docs/StoriesApi.md#send_message_story_text_0) | **POST** /messages/story/text | 💬 Send story text message
*UsersApi* | [**get_user_profile**](docs/UsersApi.md#get_user_profile) | **GET** /users/profile | User info
*UsersApi* | [**login_user**](docs/UsersApi.md#login_user) | **GET** /users/login | Login user with QR-base64
*UsersApi* | [**login_user_image**](docs/UsersApi.md#login_user_image) | **GET** /users/login/image | Login user with QR-image
*UsersApi* | [**login_user_row_data**](docs/UsersApi.md#login_user_row_data) | **GET** /users/login/rowdata | Login user with QR-rowdata
*UsersApi* | [**login_user_via_auth_code**](docs/UsersApi.md#login_user_via_auth_code) | **GET** /users/login/{PhoneNumber} | Get auth code by phone number
*UsersApi* | [**login_user_via_mobile**](docs/UsersApi.md#login_user_via_mobile) | **POST** /users/login/mobile | Login in whatsapp with phone number
*UsersApi* | [**logout_user**](docs/UsersApi.md#logout_user) | **POST** /users/logout | Logout user
*UsersApi* | [**update_user_profile**](docs/UsersApi.md#update_user_profile) | **PATCH** /users/profile | Update user info


## Documentation For Models

 - [ActionButtons](docs/ActionButtons.md)
 - [ActionList](docs/ActionList.md)
 - [ActionListSectionsInner](docs/ActionListSectionsInner.md)
 - [ActionListSectionsInnerProductItemsInner](docs/ActionListSectionsInnerProductItemsInner.md)
 - [ActionListSectionsInnerRowsInner](docs/ActionListSectionsInnerRowsInner.md)
 - [ActionProduct](docs/ActionProduct.md)
 - [AddLabelAssociationAssociationIDParameter](docs/AddLabelAssociationAssociationIDParameter.md)
 - [ApplicationRequest](docs/ApplicationRequest.md)
 - [ArchiveChatRequest](docs/ArchiveChatRequest.md)
 - [AuthCode](docs/AuthCode.md)
 - [BusinessCollection](docs/BusinessCollection.md)
 - [BusinessCollectionCreate](docs/BusinessCollectionCreate.md)
 - [BusinessCollectionEdit](docs/BusinessCollectionEdit.md)
 - [BusinessCollectionEditResult](docs/BusinessCollectionEditResult.md)
 - [BusinessCollectionList](docs/BusinessCollectionList.md)
 - [BusinessHours](docs/BusinessHours.md)
 - [BusinessProfile](docs/BusinessProfile.md)
 - [BusinessProfileCustom](docs/BusinessProfileCustom.md)
 - [BusinessProfileCustomHours](docs/BusinessProfileCustomHours.md)
 - [Button](docs/Button.md)
 - [ButtonList](docs/ButtonList.md)
 - [ButtonsReply](docs/ButtonsReply.md)
 - [CallEvent](docs/CallEvent.md)
 - [ChangeCommunitySettingsRequest](docs/ChangeCommunitySettingsRequest.md)
 - [ChannelStatus](docs/ChannelStatus.md)
 - [Chat](docs/Chat.md)
 - [ChatUpdate](docs/ChatUpdate.md)
 - [ChatsList](docs/ChatsList.md)
 - [CheckContact](docs/CheckContact.md)
 - [CheckContactRequest](docs/CheckContactRequest.md)
 - [CheckContactResponse](docs/CheckContactResponse.md)
 - [CommunitySubGroups](docs/CommunitySubGroups.md)
 - [CommunitySubGroupsAnnounceGroupInfo](docs/CommunitySubGroupsAnnounceGroupInfo.md)
 - [CommunitySubGroupsOtherGroupsInner](docs/CommunitySubGroupsOtherGroupsInner.md)
 - [CommunitySubGroupsOtherGroupsInnerProperties](docs/CommunitySubGroupsOtherGroupsInnerProperties.md)
 - [Contact](docs/Contact.md)
 - [ContactUpdate](docs/ContactUpdate.md)
 - [ContactsList](docs/ContactsList.md)
 - [CreateCommunityRequest](docs/CreateCommunityRequest.md)
 - [CreateGroupRequest](docs/CreateGroupRequest.md)
 - [CreateNewsletterAdminInviteRequest](docs/CreateNewsletterAdminInviteRequest.md)
 - [CreateNewsletterRequest](docs/CreateNewsletterRequest.md)
 - [Currency](docs/Currency.md)
 - [EditNewsletterRequest](docs/EditNewsletterRequest.md)
 - [Error](docs/Error.md)
 - [Event](docs/Event.md)
 - [EventResponse](docs/EventResponse.md)
 - [ForwardMessage](docs/ForwardMessage.md)
 - [GetPresenceEntryIDParameter](docs/GetPresenceEntryIDParameter.md)
 - [Group](docs/Group.md)
 - [GroupApplication](docs/GroupApplication.md)
 - [GroupApplicationChange](docs/GroupApplicationChange.md)
 - [GroupApplicationList](docs/GroupApplicationList.md)
 - [GroupCreate](docs/GroupCreate.md)
 - [GroupIconParameters](docs/GroupIconParameters.md)
 - [GroupIconParametersMedia](docs/GroupIconParametersMedia.md)
 - [GroupInfoByInviteCode](docs/GroupInfoByInviteCode.md)
 - [GroupInvite](docs/GroupInvite.md)
 - [GroupUpdate](docs/GroupUpdate.md)
 - [GroupsList](docs/GroupsList.md)
 - [HSMButton](docs/HSMButton.md)
 - [Health](docs/Health.md)
 - [InteractiveAction](docs/InteractiveAction.md)
 - [InteractiveType](docs/InteractiveType.md)
 - [Iterator](docs/Iterator.md)
 - [Label](docs/Label.md)
 - [LabelAssociations](docs/LabelAssociations.md)
 - [Limits](docs/Limits.md)
 - [ListParticipantsRequest](docs/ListParticipantsRequest.md)
 - [ListReply](docs/ListReply.md)
 - [MediaFile](docs/MediaFile.md)
 - [MediaFilesList](docs/MediaFilesList.md)
 - [MediaMessageType](docs/MediaMessageType.md)
 - [MediaSettings](docs/MediaSettings.md)
 - [Mentions](docs/Mentions.md)
 - [Message](docs/Message.md)
 - [MessageAction](docs/MessageAction.md)
 - [MessageContent](docs/MessageContent.md)
 - [MessageContentAudio](docs/MessageContentAudio.md)
 - [MessageContentButtons](docs/MessageContentButtons.md)
 - [MessageContentButtonsButtonsInner](docs/MessageContentButtonsButtonsInner.md)
 - [MessageContentContact](docs/MessageContentContact.md)
 - [MessageContentContacts](docs/MessageContentContacts.md)
 - [MessageContentDocument](docs/MessageContentDocument.md)
 - [MessageContentEvent](docs/MessageContentEvent.md)
 - [MessageContentHSM](docs/MessageContentHSM.md)
 - [MessageContentHSMHeader](docs/MessageContentHSMHeader.md)
 - [MessageContentImage](docs/MessageContentImage.md)
 - [MessageContentInteractive](docs/MessageContentInteractive.md)
 - [MessageContentLinkPreview](docs/MessageContentLinkPreview.md)
 - [MessageContentList](docs/MessageContentList.md)
 - [MessageContentListSectionsInner](docs/MessageContentListSectionsInner.md)
 - [MessageContentListSectionsInnerRowsInner](docs/MessageContentListSectionsInnerRowsInner.md)
 - [MessageContentLiveLocation](docs/MessageContentLiveLocation.md)
 - [MessageContentLocation](docs/MessageContentLocation.md)
 - [MessageContentNewsletterAdminInvite](docs/MessageContentNewsletterAdminInvite.md)
 - [MessageContentOrder](docs/MessageContentOrder.md)
 - [MessageContentPoll](docs/MessageContentPoll.md)
 - [MessageContentProduct](docs/MessageContentProduct.md)
 - [MessageContentProductItems](docs/MessageContentProductItems.md)
 - [MessageContentReply](docs/MessageContentReply.md)
 - [MessageContentSticker](docs/MessageContentSticker.md)
 - [MessageContentSystem](docs/MessageContentSystem.md)
 - [MessageContentText](docs/MessageContentText.md)
 - [MessageContentVideo](docs/MessageContentVideo.md)
 - [MessageContext](docs/MessageContext.md)
 - [MessageContextAD](docs/MessageContextAD.md)
 - [MessageContextADSource](docs/MessageContextADSource.md)
 - [MessageContextConversion](docs/MessageContextConversion.md)
 - [MessageMediaFileParametersForMediaUpload](docs/MessageMediaFileParametersForMediaUpload.md)
 - [MessageMediaFileParametersForMediaUploadMedia](docs/MessageMediaFileParametersForMediaUploadMedia.md)
 - [MessagePollResults](docs/MessagePollResults.md)
 - [MessagePropsAudio](docs/MessagePropsAudio.md)
 - [MessagePropsDocument](docs/MessagePropsDocument.md)
 - [MessagePropsGif](docs/MessagePropsGif.md)
 - [MessagePropsImageOrVideo](docs/MessagePropsImageOrVideo.md)
 - [MessagePropsInteractive](docs/MessagePropsInteractive.md)
 - [MessagePropsInteractiveBody](docs/MessagePropsInteractiveBody.md)
 - [MessagePropsInteractiveFooter](docs/MessagePropsInteractiveFooter.md)
 - [MessagePropsInteractiveHeader](docs/MessagePropsInteractiveHeader.md)
 - [MessagePropsLinkPreview](docs/MessagePropsLinkPreview.md)
 - [MessagePropsPoll](docs/MessagePropsPoll.md)
 - [MessagePropsSticker](docs/MessagePropsSticker.md)
 - [MessagePropsText](docs/MessagePropsText.md)
 - [MessagePropsVoice](docs/MessagePropsVoice.md)
 - [MessageReaction](docs/MessageReaction.md)
 - [MessageSource](docs/MessageSource.md)
 - [MessageType](docs/MessageType.md)
 - [MessageUpdate](docs/MessageUpdate.md)
 - [MessagesList](docs/MessagesList.md)
 - [MobileLoginMethod](docs/MobileLoginMethod.md)
 - [MobileLoginStatus](docs/MobileLoginStatus.md)
 - [MobileLoginStatusPhoneNumber](docs/MobileLoginStatusPhoneNumber.md)
 - [NewGroup](docs/NewGroup.md)
 - [Newsletter](docs/Newsletter.md)
 - [NewslettersList](docs/NewslettersList.md)
 - [NewslettersListPaged](docs/NewslettersListPaged.md)
 - [OrderItems](docs/OrderItems.md)
 - [Paging](docs/Paging.md)
 - [Participant](docs/Participant.md)
 - [ParticipantEvent](docs/ParticipantEvent.md)
 - [Participants](docs/Participants.md)
 - [PatchChatRequest](docs/PatchChatRequest.md)
 - [PollResults](docs/PollResults.md)
 - [Presence](docs/Presence.md)
 - [Product](docs/Product.md)
 - [ProductCreate](docs/ProductCreate.md)
 - [ProductEdit](docs/ProductEdit.md)
 - [ProductItem](docs/ProductItem.md)
 - [ProductsList](docs/ProductsList.md)
 - [QR](docs/QR.md)
 - [QRParameters](docs/QRParameters.md)
 - [ReactToMessage](docs/ReactToMessage.md)
 - [RequestMobileLogin](docs/RequestMobileLogin.md)
 - [ResponseError](docs/ResponseError.md)
 - [ResponseListParticipants](docs/ResponseListParticipants.md)
 - [ResponseSuccess](docs/ResponseSuccess.md)
 - [SectionList](docs/SectionList.md)
 - [SectionListList](docs/SectionListList.md)
 - [SectionListListSectionsInner](docs/SectionListListSectionsInner.md)
 - [SendMePresenceRequest](docs/SendMePresenceRequest.md)
 - [SendMedia](docs/SendMedia.md)
 - [SendMediaMedia](docs/SendMediaMedia.md)
 - [SendPresenceRequest](docs/SendPresenceRequest.md)
 - [Sender](docs/Sender.md)
 - [SenderAudio](docs/SenderAudio.md)
 - [SenderCatalogByID](docs/SenderCatalogByID.md)
 - [SenderContact](docs/SenderContact.md)
 - [SenderContactFromPhonebook](docs/SenderContactFromPhonebook.md)
 - [SenderContactList](docs/SenderContactList.md)
 - [SenderDocument](docs/SenderDocument.md)
 - [SenderGif](docs/SenderGif.md)
 - [SenderGroupInviteByCode](docs/SenderGroupInviteByCode.md)
 - [SenderImage](docs/SenderImage.md)
 - [SenderInteractive](docs/SenderInteractive.md)
 - [SenderLinkPreview](docs/SenderLinkPreview.md)
 - [SenderLiveLocation](docs/SenderLiveLocation.md)
 - [SenderLocation](docs/SenderLocation.md)
 - [SenderMedia](docs/SenderMedia.md)
 - [SenderNewsletterInviteByCode](docs/SenderNewsletterInviteByCode.md)
 - [SenderPoll](docs/SenderPoll.md)
 - [SenderProductFromCatalog](docs/SenderProductFromCatalog.md)
 - [SenderShort](docs/SenderShort.md)
 - [SenderSticker](docs/SenderSticker.md)
 - [SenderStories](docs/SenderStories.md)
 - [SenderStoriesAudio](docs/SenderStoriesAudio.md)
 - [SenderStoriesMedia](docs/SenderStoriesMedia.md)
 - [SenderStoriesText](docs/SenderStoriesText.md)
 - [SenderText](docs/SenderText.md)
 - [SenderVideo](docs/SenderVideo.md)
 - [SenderVoice](docs/SenderVoice.md)
 - [SentMessage](docs/SentMessage.md)
 - [Settings](docs/Settings.md)
 - [Size](docs/Size.md)
 - [Star](docs/Star.md)
 - [Status](docs/Status.md)
 - [StatusEnum](docs/StatusEnum.md)
 - [StatusesList](docs/StatusesList.md)
 - [UpdateGroupInfoRequest](docs/UpdateGroupInfoRequest.md)
 - [UpdateGroupSettingRequest](docs/UpdateGroupSettingRequest.md)
 - [UpdateSettings](docs/UpdateSettings.md)
 - [UploadMedia](docs/UploadMedia.md)
 - [UploadMediaResponse](docs/UploadMediaResponse.md)
 - [UserProfile](docs/UserProfile.md)
 - [UserProfileUpdate](docs/UserProfileUpdate.md)
 - [VCard](docs/VCard.md)
 - [ViewOnce](docs/ViewOnce.md)
 - [Webhook](docs/Webhook.md)
 - [WebhookEventType](docs/WebhookEventType.md)
 - [WebhookParameters](docs/WebhookParameters.md)
 - [WebhookPayload](docs/WebhookPayload.md)
 - [WebhookTestRequest](docs/WebhookTestRequest.md)


<a id="documentation-for-authorization"></a>
## Documentation For Authorization


Authentication schemes defined for the API:
<a id="bearerAuth"></a>
### bearerAuth

- **Type**: Bearer authentication (token)

<a id="tokenAuth"></a>
### tokenAuth

- **Type**: API key
- **API key parameter name**: token
- **Location**: URL query string


## Author

care@whapi.cloud


