# Chat


## Properties

Name | Type | Description | Notes
------------ | ------------- | ------------- | -------------
**id** | **str** | Chat ID | 
**name** | **str** | Chat name | [optional] 
**type** | **str** | Chat type | 
**timestamp** | **int** | Chat timestamp | [optional] 
**chat_pic** | **str** | Chat picture URL | [optional] 
**chat_pic_full** | **str** | Chat full picture URL | [optional] 
**pin** | **bool** | Is chat pinned | [optional] 
**mute** | **bool** | Is chat muted | [optional] 
**mute_until** | **int** | Chat mute until | [optional] 
**archive** | **bool** | Is chat archived | [optional] 
**unread** | **int** | Unread messages count | [optional] 
**unread_mention** | **bool** | Is chat unread mention | [optional] 
**read_only** | **bool** | Is chat read only | [optional] 
**not_spam** | **bool** | Is chat not spam | [optional] 
**last_message** | [**Message**](Message.md) |  | [optional] 
**labels** | [**List[Label]**](Label.md) | Labels associated with chat | [optional] 

## Example

```python
from openapi_client.models.chat import Chat

# TODO update the JSON string below
json = "{}"
# create an instance of Chat from a JSON string
chat_instance = Chat.from_json(json)
# print the JSON string representation of the object
print(Chat.to_json())

# convert the object into a dict
chat_dict = chat_instance.to_dict()
# create an instance of Chat from a dict
chat_from_dict = Chat.from_dict(chat_dict)
```
[[Back to Model list]](../README.md#documentation-for-models) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to README]](../README.md)


