# Group


## Properties

Name | Type | Description | Notes
------------ | ------------- | ------------- | -------------
**id** | **str** | Chat ID | 
**name** | **str** | Group name | 
**type** | **str** | Chat type | 
**timestamp** | **int** | Chat timestamp | [optional] 
**chat_pic** | **str** | Chat picture URL | [optional] 
**chat_pic_full** | **str** | Chat full picture URL | [optional] 
**pin** | **bool** | Is chat pinned | [optional] 
**mute** | **bool** | Is chat muted | [optional] 
**mute_until** | **int** | Chat mute until | [optional] 
**archive** | **bool** | Is chat archived | [optional] 
**unread** | **int** | Unread messages count | [optional] 
**unread_mention** | **bool** | Is chat unread mention | [optional] 
**read_only** | **bool** | Is chat read only | [optional] 
**not_spam** | **bool** | Is chat not spam | [optional] 
**last_message** | [**Message**](Message.md) |  | [optional] 
**labels** | [**List[Label]**](Label.md) | Labels associated with chat | [optional] 
**name_owner** | **str** | Group name owner | [optional] 
**name_at** | **int** | Group name change timestamp | [optional] 
**description** | **str** | Group description | [optional] 
**description_owner** | **str** | Group description owner | [optional] 
**description_id** | **str** | Group description ID | [optional] 
**size** | **int** | Group size | 
**participants** | [**List[Participant]**](Participant.md) | Group participants | 
**created_at** | **int** | Group creation timestamp | [optional] 
**created_by** | **str** | Contact ID | [optional] 
**suspended** | **bool** | Is group suspended | [optional] 
**terminated** | **bool** | Is group terminated | [optional] 
**is_parent** | **bool** | Is group parent | [optional] 
**is_default_subgroup** | **bool** | Is group default subgroup | [optional] 
**restricted** | **bool** | If only admins can change group settings | [optional] 
**announcements** | **bool** | If only admins can send messages | [optional] 
**ephemeral** | **float** | Group ephemeral timer | [optional] 
**invite_code** | **str** | Group invite code | [optional] 
**is_community_announce** | **bool** | If group is community announce | [optional] 
**linked_parent** | **str** | Chat ID | [optional] 

## Example

```python
from openapi_client.models.group import Group

# TODO update the JSON string below
json = "{}"
# create an instance of Group from a JSON string
group_instance = Group.from_json(json)
# print the JSON string representation of the object
print(Group.to_json())

# convert the object into a dict
group_dict = group_instance.to_dict()
# create an instance of Group from a dict
group_from_dict = Group.from_dict(group_dict)
```
[[Back to Model list]](../README.md#documentation-for-models) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to README]](../README.md)


