# Health

The health object contains information about the uptime of the channel and the status of the channel. Sent on event \"channels.post\"

## Properties

Name | Type | Description | Notes
------------ | ------------- | ------------- | -------------
**start_at** | **float** | Date timestamp when channel started on the server. | 
**uptime** | **float** | Seconds have passed since the start of the instance. | 
**version** | **str** | Channel version | [optional] 
**device_id** | **float** | Current device ID | [optional] 
**ip** | **str** | Current channel ip-address | [optional] 
**status** | [**ChannelStatus**](ChannelStatus.md) |  | 
**user** | [**Contact**](Contact.md) |  | [optional] 

## Example

```python
from openapi_client.models.health import Health

# TODO update the JSON string below
json = "{}"
# create an instance of Health from a JSON string
health_instance = Health.from_json(json)
# print the JSON string representation of the object
print(Health.to_json())

# convert the object into a dict
health_dict = health_instance.to_dict()
# create an instance of Health from a dict
health_from_dict = Health.from_dict(health_dict)
```
[[Back to Model list]](../README.md#documentation-for-models) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to README]](../README.md)


