# Message


## Properties

Name | Type | Description | Notes
------------ | ------------- | ------------- | -------------
**id** | **str** | Message ID | 
**type** | [**MessageType**](MessageType.md) |  | [default to MessageType.TEXT]
**subtype** | **str** | Message subtype | [optional] 
**chat_id** | **str** | Chat ID | 
**chat_name** | **str** | Chat name | [optional] 
**var_from** | **str** | WhatsApp ID of the sender | [optional] 
**from_me** | **bool** | Is message from me | 
**from_name** | **str** | Pushname of the sender | [optional] 
**source** | [**MessageSource**](MessageSource.md) |  | [optional] [default to text]
**timestamp** | **float** | Message timestamp | 
**device_id** | **float** | Device ID, if the message was not sent through the app | [optional] 
**status** | [**StatusEnum**](StatusEnum.md) |  | [optional] 
**text** | [**MessageContentText**](MessageContentText.md) |  | [optional] 
**image** | [**MessageContentImage**](MessageContentImage.md) |  | [optional] 
**video** | [**MessageContentVideo**](MessageContentVideo.md) |  | [optional] 
**short** | [**MessageContentVideo**](MessageContentVideo.md) |  | [optional] 
**gif** | [**MessageContentVideo**](MessageContentVideo.md) |  | [optional] 
**audio** | [**MessageContentAudio**](MessageContentAudio.md) |  | [optional] 
**voice** | [**MessageContentAudio**](MessageContentAudio.md) |  | [optional] 
**document** | [**MessageContentDocument**](MessageContentDocument.md) |  | [optional] 
**link_preview** | [**MessageContentLinkPreview**](MessageContentLinkPreview.md) |  | [optional] 
**sticker** | [**MessageContentSticker**](MessageContentSticker.md) |  | [optional] 
**location** | [**MessageContentLocation**](MessageContentLocation.md) |  | [optional] 
**live_location** | [**MessageContentLiveLocation**](MessageContentLiveLocation.md) |  | [optional] 
**contact** | [**MessageContentContact**](MessageContentContact.md) |  | [optional] 
**contact_list** | [**MessageContentContacts**](MessageContentContacts.md) |  | [optional] 
**interactive** | [**MessageContentInteractive**](MessageContentInteractive.md) |  | [optional] 
**poll** | [**MessageContentPoll**](MessageContentPoll.md) |  | [optional] 
**hsm** | [**MessageContentHSM**](MessageContentHSM.md) |  | [optional] 
**system** | [**MessageContentSystem**](MessageContentSystem.md) |  | [optional] 
**order** | [**MessageContentOrder**](MessageContentOrder.md) |  | [optional] 
**group_invite** | [**MessageContentLinkPreview**](MessageContentLinkPreview.md) |  | [optional] 
**newsletter_invite** | [**MessageContentLinkPreview**](MessageContentLinkPreview.md) |  | [optional] 
**admin_invite** | [**MessageContentNewsletterAdminInvite**](MessageContentNewsletterAdminInvite.md) |  | [optional] 
**product** | [**MessageContentProduct**](MessageContentProduct.md) |  | [optional] 
**catalog** | [**MessageContentLinkPreview**](MessageContentLinkPreview.md) |  | [optional] 
**product_items** | [**MessageContentProductItems**](MessageContentProductItems.md) |  | [optional] 
**action** | [**MessageAction**](MessageAction.md) |  | [optional] 
**context** | [**MessageContext**](MessageContext.md) |  | [optional] 
**event** | [**MessageContentEvent**](MessageContentEvent.md) |  | [optional] 
**list** | [**MessageContentList**](MessageContentList.md) |  | [optional] 
**buttons** | [**MessageContentButtons**](MessageContentButtons.md) |  | [optional] 
**reactions** | [**List[MessageReaction]**](MessageReaction.md) | Reactions for message | [optional] 
**labels** | [**List[Label]**](Label.md) | Labels associated with message | [optional] 

## Example

```python
from openapi_client.models.message import Message

# TODO update the JSON string below
json = "{}"
# create an instance of Message from a JSON string
message_instance = Message.from_json(json)
# print the JSON string representation of the object
print(Message.to_json())

# convert the object into a dict
message_dict = message_instance.to_dict()
# create an instance of Message from a dict
message_from_dict = Message.from_dict(message_dict)
```
[[Back to Model list]](../README.md#documentation-for-models) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to README]](../README.md)


