# MessageContent


## Properties

Name | Type | Description | Notes
------------ | ------------- | ------------- | -------------
**body** | [**MessagePropsInteractiveBody**](MessagePropsInteractiveBody.md) |  | 
**buttons** | [**List[Button]**](Button.md) |  | [optional] 
**sections** | [**List[ActionListSectionsInner]**](ActionListSectionsInner.md) | Section of the message | [optional] 
**button** | **str** | Button text for list of message | [optional] 
**view_once** | **bool** | Is view once | [optional] 
**id** | **str** | Media ID | 
**link** | **str** | Optional. Link to media | [optional] 
**mime_type** | **str** | Mime type of media | 
**file_size** | **int** | File size in bytes | 
**file_name** | **str** | Optional. File name | [optional] 
**sha256** | **str** | Checksum | [optional] 
**timestamp** | **float** | Created at | [optional] 
**caption** | **str** | Optional. Text caption under the live location | [optional] 
**preview** | **str** | Optional. Base64 encoded preview of the media. In JPEG format. | [optional] 
**width** | **int** | Width of the media in pixels | [optional] 
**height** | **int** | Height of the media in pixels | [optional] 
**seconds** | **int** | Optional. For audio files, this field indicates the duration of the audio file in seconds. | [optional] 
**autoplay** | **bool** | Optional. If the media is a GIF, this field indicates whether the GIF should be played automatically when the message is received. | [optional] 
**recording_time** | **float** | Time in seconds to simulate recording voice | [optional] [default to 0]
**filename** | **str** | Optional. File name | [optional] 
**page_count** | **int** | Optional. Number of pages | [optional] 
**url** | **str** | URL for the website where the user downloaded the location information | [optional] 
**catalog_id** | **str** | Catalog ID | [optional] 
**newsletter_id** | **str** | Newsletter ID | 
**invite_code** | **str** | Invite code | [optional] 
**title** | **str** | Title of poll | 
**description** | **str** | Description of the link | [optional] 
**canonical** | **str** | Canonical URL of the link (for example, if the link is shortened) | [optional] 
**newsletter_name** | **str** | Newsletter name | 
**expiration** | **float** | Expiration timestamp of the invitation | 
**product_id** | **str** | Product ID | [optional] 
**animated** | **bool** | Optional. For stickers, this field indicates whether the sticker is animated. | [optional] 
**latitude** | **float** | Latitude of live location being sent | 
**longitude** | **float** | Longitude of live location being sent | 
**address** | **str** | Address of the location | [optional] 
**name** | **str** | Name of contact | [optional] 
**accuracy** | **int** | Accuracy of the live location in meters | [optional] 
**speed** | **int** | Speed of the live location in meters per second | [optional] 
**degrees** | **int** | Degrees clockwise from true north | [optional] 
**comment** | **str** | Optional. Comment for the location | [optional] 
**sequence_number** | **int** | Optional. Sequence number of the live location for event tracking | [optional] 
**time_offset** | **float** | Optional. Time offset of the live location | [optional] 
**vcard** | **str** | Vcard of contact | [optional] 
**list** | [**List[VCard]**](VCard.md) |  | [optional] 
**header** | [**MessagePropsInteractiveHeader**](MessagePropsInteractiveHeader.md) |  | [optional] 
**footer** | [**MessagePropsInteractiveFooter**](MessagePropsInteractiveFooter.md) |  | [optional] 
**action** | [**InteractiveAction**](InteractiveAction.md) |  | 
**type** | [**InteractiveType**](InteractiveType.md) |  | [optional] [default to InteractiveType.BUTTON]
**options** | **List[str]** | Options of poll | 
**vote_limit** | **int** | Number of selectable options in poll (1 - can choose only one option, 0 - any number of options) | [optional] 
**total** | **int** | Total count of selected options | [optional] 
**results** | [**List[PollResults]**](PollResults.md) |  | [optional] 
**list_reply** | [**ListReply**](ListReply.md) |  | [optional] 
**buttons_reply** | [**ButtonsReply**](ButtonsReply.md) |  | [optional] 

## Example

```python
from openapi_client.models.message_content import MessageContent

# TODO update the JSON string below
json = "{}"
# create an instance of MessageContent from a JSON string
message_content_instance = MessageContent.from_json(json)
# print the JSON string representation of the object
print(MessageContent.to_json())

# convert the object into a dict
message_content_dict = message_content_instance.to_dict()
# create an instance of MessageContent from a dict
message_content_from_dict = MessageContent.from_dict(message_content_dict)
```
[[Back to Model list]](../README.md#documentation-for-models) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to README]](../README.md)


