# MessageContentVideo


## Properties

Name | Type | Description | Notes
------------ | ------------- | ------------- | -------------
**id** | **str** | Media ID | 
**link** | **str** | Optional. Link to media | [optional] 
**mime_type** | **str** | Mime type of media | 
**file_size** | **int** | File size in bytes | 
**file_name** | **str** | Optional. File name | [optional] 
**sha256** | **str** | Checksum | [optional] 
**timestamp** | **float** | Created at | [optional] 
**caption** | **str** | Optional. Text caption under the media. | [optional] 
**preview** | **str** | Optional. Base64 encoded preview of the media. In JPEG format. | [optional] 
**width** | **int** | Width of the media in pixels | [optional] 
**height** | **int** | Height of the media in pixels | [optional] 
**buttons** | [**List[Button]**](Button.md) |  | [optional] 
**view_once** | **bool** | Is view once | [optional] 
**seconds** | **int** | Optional. For video files, this field indicates the duration of the video file in seconds. | [optional] 
**autoplay** | **bool** | Optional. If the media is a GIF, this field indicates whether the GIF should be played automatically when the message is received. | [optional] 

## Example

```python
from openapi_client.models.message_content_video import MessageContentVideo

# TODO update the JSON string below
json = "{}"
# create an instance of MessageContentVideo from a JSON string
message_content_video_instance = MessageContentVideo.from_json(json)
# print the JSON string representation of the object
print(MessageContentVideo.to_json())

# convert the object into a dict
message_content_video_dict = message_content_video_instance.to_dict()
# create an instance of MessageContentVideo from a dict
message_content_video_from_dict = MessageContentVideo.from_dict(message_content_video_dict)
```
[[Back to Model list]](../README.md#documentation-for-models) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to README]](../README.md)


