# Newsletter


## Properties

Name | Type | Description | Notes
------------ | ------------- | ------------- | -------------
**id** | **str** | Chat ID | 
**name** | **str** | Newsletter name | 
**type** | **str** | Chat type | 
**timestamp** | **int** | Chat timestamp | [optional] 
**chat_pic** | **str** | Chat picture URL | [optional] 
**chat_pic_full** | **str** | Chat full picture URL | [optional] 
**pin** | **bool** | Is chat pinned | [optional] 
**mute** | **bool** | Is chat muted | [optional] 
**mute_until** | **int** | Chat mute until | [optional] 
**archive** | **bool** | Is chat archived | [optional] 
**unread** | **int** | Unread messages count | [optional] 
**unread_mention** | **bool** | Is chat unread mention | [optional] 
**read_only** | **bool** | Is chat read only | [optional] 
**not_spam** | **bool** | Is chat not spam | [optional] 
**last_message** | [**Message**](Message.md) |  | [optional] 
**labels** | [**List[Label]**](Label.md) | Labels associated with chat | [optional] 
**name_at** | **int** | Newsletter name change timestamp | [optional] 
**description** | **str** | Newsletter description | [optional] 
**description_at** | **str** | Newsletter description change timestamp | [optional] 
**subscribers_count** | **int** | Newsletter subscribers count | [optional] 
**created_at** | **int** | Newsletter creation timestamp | [optional] 
**invite_code** | **str** | Newsletter invite code | [optional] 
**handle** | **str** | Newsletter handle | [optional] 
**verification** | **bool** | Is newsletter verified | [optional] 
**preview** | **str** | Newsletter preview URL | [optional] 
**role** | **str** | User&#39;s role regarding the newsletter | [optional] 

## Example

```python
from openapi_client.models.newsletter import Newsletter

# TODO update the JSON string below
json = "{}"
# create an instance of Newsletter from a JSON string
newsletter_instance = Newsletter.from_json(json)
# print the JSON string representation of the object
print(Newsletter.to_json())

# convert the object into a dict
newsletter_dict = newsletter_instance.to_dict()
# create an instance of Newsletter from a dict
newsletter_from_dict = Newsletter.from_dict(newsletter_dict)
```
[[Back to Model list]](../README.md#documentation-for-models) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to README]](../README.md)


