# SenderInteractive


## Properties

Name | Type | Description | Notes
------------ | ------------- | ------------- | -------------
**to** | **str** | Use the phone number or [Chat ID](https://support.whapi.cloud/help-desk/faq/chat-id.-what-is-it-and-how-to-get-it) of the contact/group/channel to which you want to send the message. Use [Get groups](https://whapi.readme.io/reference/getgroups) to get the group ID. | 
**quoted** | **str** | Message ID of the message to be quoted | [optional] 
**ephemeral** | **int** | Time in seconds for the message to be deleted. The Disappearing messages setting should be enabled in the chat where you are sending this message. | [optional] 
**edit** | **str** | Message ID of the message to be edited | [optional] 
**header** | [**MessagePropsInteractiveHeader**](MessagePropsInteractiveHeader.md) |  | [optional] 
**body** | [**MessagePropsInteractiveBody**](MessagePropsInteractiveBody.md) |  | [optional] 
**footer** | [**MessagePropsInteractiveFooter**](MessagePropsInteractiveFooter.md) |  | [optional] 
**action** | [**InteractiveAction**](InteractiveAction.md) |  | 
**type** | [**InteractiveType**](InteractiveType.md) |  | [optional] [default to InteractiveType.BUTTON]
**view_once** | **bool** | Is view once | [optional] 

## Example

```python
from openapi_client.models.sender_interactive import SenderInteractive

# TODO update the JSON string below
json = "{}"
# create an instance of SenderInteractive from a JSON string
sender_interactive_instance = SenderInteractive.from_json(json)
# print the JSON string representation of the object
print(SenderInteractive.to_json())

# convert the object into a dict
sender_interactive_dict = sender_interactive_instance.to_dict()
# create an instance of SenderInteractive from a dict
sender_interactive_from_dict = SenderInteractive.from_dict(sender_interactive_dict)
```
[[Back to Model list]](../README.md#documentation-for-models) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to README]](../README.md)


