# SenderLocation


## Properties

Name | Type | Description | Notes
------------ | ------------- | ------------- | -------------
**to** | **str** | Use the phone number or [Chat ID](https://support.whapi.cloud/help-desk/faq/chat-id.-what-is-it-and-how-to-get-it) of the contact/group/channel to which you want to send the message. Use [Get groups](https://whapi.readme.io/reference/getgroups) to get the group ID. | 
**quoted** | **str** | Message ID of the message to be quoted | [optional] 
**ephemeral** | **int** | Time in seconds for the message to be deleted. The Disappearing messages setting should be enabled in the chat where you are sending this message. | [optional] 
**edit** | **str** | Message ID of the message to be edited | [optional] 
**latitude** | **float** | Latitude of location being sent | 
**longitude** | **float** | Longitude of location being sent | 
**address** | **str** | Address of the location | [optional] 
**name** | **str** | Name of the location | [optional] 
**url** | **str** | URL for the website where the user downloaded the location information | [optional] 
**preview** | **str** | Optional. Base64 encoded preview of the media. In JPEG format. | [optional] 
**accuracy** | **int** | Accuracy of the location in meters | [optional] 
**speed** | **int** | Speed of the location in meters per second | [optional] 
**degrees** | **int** | Degrees clockwise from true north | [optional] 
**comment** | **str** | Optional. Comment for the location | [optional] 
**view_once** | **bool** | Is view once | [optional] 

## Example

```python
from openapi_client.models.sender_location import SenderLocation

# TODO update the JSON string below
json = "{}"
# create an instance of SenderLocation from a JSON string
sender_location_instance = SenderLocation.from_json(json)
# print the JSON string representation of the object
print(SenderLocation.to_json())

# convert the object into a dict
sender_location_dict = sender_location_instance.to_dict()
# create an instance of SenderLocation from a dict
sender_location_from_dict = SenderLocation.from_dict(sender_location_dict)
```
[[Back to Model list]](../README.md#documentation-for-models) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to README]](../README.md)


