# SenderPoll


## Properties

Name | Type | Description | Notes
------------ | ------------- | ------------- | -------------
**to** | **str** | Use the phone number or [Chat ID](https://support.whapi.cloud/help-desk/faq/chat-id.-what-is-it-and-how-to-get-it) of the contact/group/channel to which you want to send the message. Use [Get groups](https://whapi.readme.io/reference/getgroups) to get the group ID. | 
**quoted** | **str** | Message ID of the message to be quoted | [optional] 
**ephemeral** | **int** | Time in seconds for the message to be deleted. The Disappearing messages setting should be enabled in the chat where you are sending this message. | [optional] 
**edit** | **str** | Message ID of the message to be edited | [optional] 
**title** | **str** | Title of poll | 
**options** | **List[str]** | Options of poll | 
**count** | **int** | Number of selectable options in poll (1 - can choose only one option, 0 - any number of options) | [optional] 
**view_once** | **bool** | Is view once | [optional] 

## Example

```python
from openapi_client.models.sender_poll import SenderPoll

# TODO update the JSON string below
json = "{}"
# create an instance of SenderPoll from a JSON string
sender_poll_instance = SenderPoll.from_json(json)
# print the JSON string representation of the object
print(SenderPoll.to_json())

# convert the object into a dict
sender_poll_dict = sender_poll_instance.to_dict()
# create an instance of SenderPoll from a dict
sender_poll_from_dict = SenderPoll.from_dict(sender_poll_dict)
```
[[Back to Model list]](../README.md#documentation-for-models) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to README]](../README.md)


