# SenderShort


## Properties

Name | Type | Description | Notes
------------ | ------------- | ------------- | -------------
**to** | **str** | Use the phone number or [Chat ID](https://support.whapi.cloud/help-desk/faq/chat-id.-what-is-it-and-how-to-get-it) of the contact/group/channel to which you want to send the message. Use [Get groups](https://whapi.readme.io/reference/getgroups) to get the group ID. | 
**quoted** | **str** | Message ID of the message to be quoted | [optional] 
**ephemeral** | **int** | Time in seconds for the message to be deleted. The Disappearing messages setting should be enabled in the chat where you are sending this message. | [optional] 
**edit** | **str** | Message ID of the message to be edited | [optional] 
**media** | [**SendMediaMedia**](SendMediaMedia.md) |  | 
**mime_type** | **str** | Mime type of media | [optional] 
**no_encode** | **bool** | Do not use our encoding | [optional] 
**no_cache** | **bool** | Do not use the cache in a request | [optional] 
**caption** | **str** | Optional. Text caption under the media. | [optional] 
**preview** | **str** | Optional. Base64 encoded preview of the media. In JPEG format. | [optional] 
**width** | **int** | Width of the media in pixels | [optional] 
**height** | **int** | Height of the media in pixels | [optional] 
**mentions** | **List[str]** | The numbers of the mentioned users | [optional] 
**view_once** | **bool** | Is view once | [optional] 

## Example

```python
from openapi_client.models.sender_short import SenderShort

# TODO update the JSON string below
json = "{}"
# create an instance of SenderShort from a JSON string
sender_short_instance = SenderShort.from_json(json)
# print the JSON string representation of the object
print(SenderShort.to_json())

# convert the object into a dict
sender_short_dict = sender_short_instance.to_dict()
# create an instance of SenderShort from a dict
sender_short_from_dict = SenderShort.from_dict(sender_short_dict)
```
[[Back to Model list]](../README.md#documentation-for-models) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to README]](../README.md)


