# SenderSticker


## Properties

Name | Type | Description | Notes
------------ | ------------- | ------------- | -------------
**to** | **str** | Use the phone number or [Chat ID](https://support.whapi.cloud/help-desk/faq/chat-id.-what-is-it-and-how-to-get-it) of the contact/group/channel to which you want to send the message. Use [Get groups](https://whapi.readme.io/reference/getgroups) to get the group ID. | 
**quoted** | **str** | Message ID of the message to be quoted | [optional] 
**ephemeral** | **int** | Time in seconds for the message to be deleted. The Disappearing messages setting should be enabled in the chat where you are sending this message. | [optional] 
**edit** | **str** | Message ID of the message to be edited | [optional] 
**media** | [**SendMediaMedia**](SendMediaMedia.md) |  | 
**mime_type** | **str** | Mime type of media | [optional] 
**no_encode** | **bool** | Do not use our encoding | [optional] 
**no_cache** | **bool** | Do not use the cache in a request | [optional] 
**animated** | **bool** | Optional. For stickers, this field indicates whether the sticker is animated. | [optional] 
**width** | **int** | Width of the media in pixels | [optional] 
**height** | **int** | Height of the media in pixels | [optional] 
**view_once** | **bool** | Is view once | [optional] 

## Example

```python
from openapi_client.models.sender_sticker import SenderSticker

# TODO update the JSON string below
json = "{}"
# create an instance of SenderSticker from a JSON string
sender_sticker_instance = SenderSticker.from_json(json)
# print the JSON string representation of the object
print(SenderSticker.to_json())

# convert the object into a dict
sender_sticker_dict = sender_sticker_instance.to_dict()
# create an instance of SenderSticker from a dict
sender_sticker_from_dict = SenderSticker.from_dict(sender_sticker_dict)
```
[[Back to Model list]](../README.md#documentation-for-models) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to README]](../README.md)


