# SenderStories


## Properties

Name | Type | Description | Notes
------------ | ------------- | ------------- | -------------
**media** | [**SendMediaMedia**](SendMediaMedia.md) |  | [optional] 
**mime_type** | **str** | Mime type of media | [optional] 
**no_encode** | **bool** | Do not use our encoding | [optional] 
**no_cache** | **bool** | Do not use the cache in a request | [optional] 
**caption** | **str** | Optional. Text caption under the media. | [optional] 
**preview** | **str** | Optional. Base64 encoded preview of the media. In JPEG format. | [optional] 
**width** | **int** | Width of the media in pixels | [optional] 
**height** | **int** | Height of the media in pixels | [optional] 
**seconds** | **int** | Optional. For audio files, this field indicates the duration of the audio file in seconds. | [optional] 
**contacts** | **List[str]** | List of contacts to send the story to | [optional] 
**background_color** | **str** | Background color of the story (ARGB) | [optional] [default to '#00000000']
**caption_color** | **str** | Caption color of the story (ARGB) | [optional] [default to '#FFFFFFFF']
**font_type** | **str** | Font style of the story | [optional] 

## Example

```python
from openapi_client.models.sender_stories import SenderStories

# TODO update the JSON string below
json = "{}"
# create an instance of SenderStories from a JSON string
sender_stories_instance = SenderStories.from_json(json)
# print the JSON string representation of the object
print(SenderStories.to_json())

# convert the object into a dict
sender_stories_dict = sender_stories_instance.to_dict()
# create an instance of SenderStories from a dict
sender_stories_from_dict = SenderStories.from_dict(sender_stories_dict)
```
[[Back to Model list]](../README.md#documentation-for-models) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to README]](../README.md)


