# SenderText


## Properties

Name | Type | Description | Notes
------------ | ------------- | ------------- | -------------
**to** | **str** | Use the phone number or [Chat ID](https://support.whapi.cloud/help-desk/faq/chat-id.-what-is-it-and-how-to-get-it) of the contact/group/channel to which you want to send the message. Use [Get groups](https://whapi.readme.io/reference/getgroups) to get the group ID. | 
**quoted** | **str** | Message ID of the message to be quoted | [optional] 
**ephemeral** | **int** | Time in seconds for the message to be deleted. The Disappearing messages setting should be enabled in the chat where you are sending this message. | [optional] 
**edit** | **str** | Message ID of the message to be edited | [optional] 
**body** | **str** | Message text | 
**mentions** | **List[str]** | The numbers of the mentioned users | [optional] 
**view_once** | **bool** | Is view once | [optional] 
**typing_time** | **float** | Time in seconds to simulate typing | [optional] [default to 0]
**no_link_preview** | **bool** | Set \&quot;true\&quot; if necessary to send the link without preview | [optional] 

## Example

```python
from openapi_client.models.sender_text import SenderText

# TODO update the JSON string below
json = "{}"
# create an instance of SenderText from a JSON string
sender_text_instance = SenderText.from_json(json)
# print the JSON string representation of the object
print(SenderText.to_json())

# convert the object into a dict
sender_text_dict = sender_text_instance.to_dict()
# create an instance of SenderText from a dict
sender_text_from_dict = SenderText.from_dict(sender_text_dict)
```
[[Back to Model list]](../README.md#documentation-for-models) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to README]](../README.md)


