# Settings


## Properties

Name | Type | Description | Notes
------------ | ------------- | ------------- | -------------
**callback_backoff_delay_ms** | **float** | Backoff delay for a failed callback in milliseconds This setting is used to configure the amount of time the backoff delays before retrying a failed callback. The backoff delay increases linearly by this value each time a callback fails to get a HTTPS 200 OK response. The backoff delay is capped by the max_callback_backoff_delay_ms setting. | [optional] 
**max_callback_backoff_delay_ms** | **float** | Maximum delay for a failed callback in milliseconds | [optional] 
**callback_persist** | **bool** | Stores callbacks on disk until they are successfully acknowledged by the Webhook or not. Restart required. | [optional] 
**media** | [**MediaSettings**](MediaSettings.md) |  | [optional] 
**webhooks** | [**List[Webhook]**](Webhook.md) |  | [optional] 
**proxy** | **str** | Use your Socks5 proxy if your account activity arouses suspicion from WhatsApp. This can help maintain anonymity and ensure smooth operation. | [optional] 
**mobile_proxy** | **str** | Service proxy for mobile authorization. | [optional] 
**offline_mode** | **bool** | When true, API will not send online status to the server on connection. This will allow you to receive push notifications to devices connected to the number. Working after reconnect. | [optional] [default to False]
**full_history** | **bool** | When true, all messages will be cached after the connection. If false, old messages will selectively not be cached, allowing large accounts to run faster. Working after reconnect. | [optional] [default to False]

## Example

```python
from openapi_client.models.settings import Settings

# TODO update the JSON string below
json = "{}"
# create an instance of Settings from a JSON string
settings_instance = Settings.from_json(json)
# print the JSON string representation of the object
print(Settings.to_json())

# convert the object into a dict
settings_dict = settings_instance.to_dict()
# create an instance of Settings from a dict
settings_from_dict = Settings.from_dict(settings_dict)
```
[[Back to Model list]](../README.md#documentation-for-models) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to README]](../README.md)


