# Webhook


## Properties

Name | Type | Description | Notes
------------ | ------------- | ------------- | -------------
**headers** | **Dict[str, str]** | Additional headers for webhook. Max 5 headers. &lt;br/&gt;Example: &lt;br/&gt;\&quot;Authorization - Bearer token\&quot; &lt;br/&gt;\&quot;Content-Type - application/json\&quot; &lt;br/&gt;\&quot;X-Header - value\&quot; | [optional] 
**url** | **str** | Inbound and outbound notifications are routed to this URL. | 
**mode** | **str** | Request method for sending hook. | [optional] [default to 'body']
**events** | [**List[Event]**](Event.md) | Tracked events. &lt;br/&gt;\&quot;messages\&quot; - got new message/got offline messages/edit message/delete message;&lt;br/&gt;\&quot;statuses\&quot; - got message status/got offline message status;&lt;br/&gt;\&quot;chats\&quot; - got chat/chat update/chat remove;&lt;br/&gt;\&quot;contacts\&quot; - contact update;&lt;br/&gt;\&quot;presences\&quot; - got presences&lt;br/&gt;\&quot;groups\&quot; - new group/participants update/group update;&lt;br/&gt;\&quot;calls\&quot; - got call events&lt;br/&gt;labels\&quot; - new label/remove label&lt;br/&gt;\&quot;users\&quot; - login user/logout user&lt;br/&gt;\&quot;channel\&quot; - instance status changed/QR-code update&lt;br/&gt;\&quot;service\&quot; - special notifications&lt;br/&gt;&lt;br/&gt;\&quot;message\&quot;, \&quot;ack\&quot;, \&quot;chat\&quot;, \&quot;status\&quot; - is deprecated, use \&quot;messages\&quot;, \&quot;statuses\&quot;, \&quot;chats\&quot;, \&quot;channel\&quot; instead. | [optional] [default to [{"type":"message","method":"put"}]]

## Example

```python
from openapi_client.models.webhook import Webhook

# TODO update the JSON string below
json = "{}"
# create an instance of Webhook from a JSON string
webhook_instance = Webhook.from_json(json)
# print the JSON string representation of the object
print(Webhook.to_json())

# convert the object into a dict
webhook_dict = webhook_instance.to_dict()
# create an instance of Webhook from a dict
webhook_from_dict = Webhook.from_dict(webhook_dict)
```
[[Back to Model list]](../README.md#documentation-for-models) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to README]](../README.md)


