# WebhookPayload



## Properties

Name | Type | Description | Notes
------------ | ------------- | ------------- | -------------
**contacts** | [**List[Contact]**](Contact.md) | The contacts array contains all contacts that were sent to the webhook URL. Sent on event \&quot;contacts.post\&quot; | [optional] 
**messages** | [**List[Message]**](Message.md) | The messages array contains all messages that were sent to the webhook URL. Sent on event \&quot;messages.post\&quot; or \&quot;messages.put\&quot; | [optional] 
**messages_updates** | [**List[MessageUpdate]**](MessageUpdate.md) | The messages updates array contains all messages updates that were sent to the webhook URL. Sent on event \&quot;messages.patch\&quot; | [optional] 
**messages_removed** | **List[str]** | The messages removed array contains all messages removed that were sent to the webhook URL. Sent on event \&quot;messages.delete\&quot; | [optional] 
**messages_removed_all** | **str** | The messages removed all contains the chat ID of the chat that was cleared. Sent on event \&quot;messages.delete\&quot; | [optional] 
**statuses** | [**List[Status]**](Status.md) | The messages statuses array contains all statuses that were sent to the webhook URL. Sent on event \&quot;statuses.post\&quot; or \&quot;statuses.put\&quot; | [optional] 
**chats** | [**List[Chat]**](Chat.md) | The chats array contains all chats that were sent to the webhook URL. Sent on event \&quot;chats.post\&quot; or \&quot;chats.put\&quot; | [optional] 
**chats_updates** | [**List[ChatUpdate]**](ChatUpdate.md) | The chats updates array contains all chats updates that were sent to the webhook URL. Sent on event \&quot;chats.patch\&quot; | [optional] 
**chats_removed** | **List[str]** | The chats removed array contains all chats removed that were sent to the webhook URL. Sent on event \&quot;chats.delete\&quot; | [optional] 
**contacts_updates** | [**List[ContactUpdate]**](ContactUpdate.md) | The contacts updates array contains all contacts updates that were sent to the webhook URL. Sent on event \&quot;contacts.patch\&quot; | [optional] 
**groups** | [**List[Group]**](Group.md) | The groups array contains all groups that were sent to the webhook URL. Sent on event \&quot;groups.post\&quot; | [optional] 
**groups_participants** | [**List[ParticipantEvent]**](ParticipantEvent.md) | The groups participants event array contains all groups participants event that were sent to the webhook URL. Sent on event \&quot;groups.put\&quot; | [optional] 
**groups_updates** | [**List[GroupUpdate]**](GroupUpdate.md) | The groups updates array contains all groups updates that were sent to the webhook URL. Sent on event \&quot;groups.patch\&quot; | [optional] 
**presences** | [**List[Presence]**](Presence.md) | The presences array contains all presences that were sent to the webhook URL. Sent on event \&quot;presences.post\&quot; | [optional] 
**labels** | [**List[Label]**](Label.md) | The labels array contains all labels that were sent to the webhook URL. Sent on event \&quot;labels.post\&quot; | [optional] 
**labels_removed** | **List[str]** | The labels removed array contains all labels removed that were sent to the webhook URL. Sent on event \&quot;labels.delete\&quot; | [optional] 
**calls** | [**List[CallEvent]**](CallEvent.md) | The calls array contains all calls that were sent to the webhook URL. Sent on event \&quot;calls.post\&quot; | [optional] 
**qr** | [**QR**](QR.md) |  | [optional] 
**health** | [**Health**](Health.md) |  | [optional] 
**user** | [**Contact**](Contact.md) |  | [optional] 
**errors** | [**List[Error]**](Error.md) |  | [optional] 
**event** | [**Event**](Event.md) |  | [optional] 
**channel_id** | **str** | The channel ID | [optional] 

## Example

```python
from openapi_client.models.webhook_payload import WebhookPayload

# TODO update the JSON string below
json = "{}"
# create an instance of WebhookPayload from a JSON string
webhook_payload_instance = WebhookPayload.from_json(json)
# print the JSON string representation of the object
print(WebhookPayload.to_json())

# convert the object into a dict
webhook_payload_dict = webhook_payload_instance.to_dict()
# create an instance of WebhookPayload from a dict
webhook_payload_from_dict = WebhookPayload.from_dict(webhook_payload_dict)
```
[[Back to Model list]](../README.md#documentation-for-models) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to README]](../README.md)


