# coding: utf-8

"""
    Whapi API

    Sending and receiving messages using HTTP requests. Fixed price with no hidden fees, without limits and restrictions. You will be able to send and receive text/media/files/locations/goods/orders/polls messages via WhatsApp in private or group chats. Guides and SDK can be found on our website.

    The version of the OpenAPI document: 1.8.7
    Contact: care@whapi.cloud
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from typing_extensions import Annotated
from openapi_client.models.business_profile_custom_hours import BusinessProfileCustomHours
from typing import Optional, Set
from typing_extensions import Self

class BusinessProfile(BaseModel):
    """
    BusinessProfile
    """ # noqa: E501
    address: Optional[StrictStr] = Field(default=None, description="Address of the business Maximum of 256 characters")
    description: Optional[StrictStr] = Field(default=None, description="Description of the business Maximum of 256 characters")
    email: Optional[StrictStr] = Field(default=None, description="Email address to contact the business Maximum of 128 characters")
    hours: Optional[BusinessProfileCustomHours] = None
    websites: Optional[List[StrictStr]] = Field(default=None, description="URLs associated with business (e.g., website, Facebook page, Instagram) Maximum of 2 websites with a maximum of 256 characters each")
    id: Optional[Annotated[str, Field(strict=True)]] = Field(default=None, description="User ID")
    __properties: ClassVar[List[str]] = ["address", "description", "email", "hours", "websites", "id"]

    @field_validator('id')
    def id_validate_regular_expression(cls, value):
        """Validates the regular expression"""
        if value is None:
            return value

        if not re.match(r"^(?:[a-zA-Z0-9]{28}|me)$", value):
            raise ValueError(r"must validate the regular expression /^(?:[a-zA-Z0-9]{28}|me)$/")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of BusinessProfile from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of hours
        if self.hours:
            _dict['hours'] = self.hours.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of BusinessProfile from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "address": obj.get("address"),
            "description": obj.get("description"),
            "email": obj.get("email"),
            "hours": BusinessProfileCustomHours.from_dict(obj["hours"]) if obj.get("hours") is not None else None,
            "websites": obj.get("websites"),
            "id": obj.get("id")
        })
        return _obj


