# coding: utf-8

"""
    Whapi API

    Sending and receiving messages using HTTP requests. Fixed price with no hidden fees, without limits and restrictions. You will be able to send and receive text/media/files/locations/goods/orders/polls messages via WhatsApp in private or group chats. Guides and SDK can be found on our website.

    The version of the OpenAPI document: 1.8.7
    Contact: care@whapi.cloud
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictInt, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class CallEvent(BaseModel):
    """
    CallEvent
    """ # noqa: E501
    id: Optional[StrictStr] = Field(default=None, description="The ID of the call.")
    chat_id: Optional[StrictStr] = Field(default=None, description="The ID of the chat that the call is associated with.")
    status: Optional[StrictStr] = Field(default=None, description="The status of the call.")
    var_from: Optional[StrictStr] = Field(default=None, description="The ID of the contact that initiated the call.", alias="from")
    timestamp: Optional[StrictInt] = Field(default=None, description="The timestamp of the call.")
    group_call: Optional[StrictBool] = Field(default=None, description="Whether the call is a group call.")
    video_call: Optional[StrictBool] = Field(default=None, description="Whether the call is a video call.")
    offline_call: Optional[StrictBool] = Field(default=None, description="Whether the call is an offline call.")
    latency: Optional[StrictInt] = Field(default=None, description="The latency of the call in milliseconds.")
    __properties: ClassVar[List[str]] = ["id", "chat_id", "status", "from", "timestamp", "group_call", "video_call", "offline_call", "latency"]

    @field_validator('status')
    def status_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(['initiated', 'ringing', 'missed', 'canceled', 'answered']):
            raise ValueError("must be one of enum values ('initiated', 'ringing', 'missed', 'canceled', 'answered')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of CallEvent from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of CallEvent from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "id": obj.get("id"),
            "chat_id": obj.get("chat_id"),
            "status": obj.get("status"),
            "from": obj.get("from"),
            "timestamp": obj.get("timestamp"),
            "group_call": obj.get("group_call"),
            "video_call": obj.get("video_call"),
            "offline_call": obj.get("offline_call"),
            "latency": obj.get("latency")
        })
        return _obj


