# coding: utf-8

"""
    Whapi API

    Sending and receiving messages using HTTP requests. Fixed price with no hidden fees, without limits and restrictions. You will be able to send and receive text/media/files/locations/goods/orders/polls messages via WhatsApp in private or group chats. Guides and SDK can be found on our website.

    The version of the OpenAPI document: 1.8.7
    Contact: care@whapi.cloud
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictInt, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from typing_extensions import Annotated
from openapi_client.models.participant import Participant
from typing import Optional, Set
from typing_extensions import Self

class GroupCreate(BaseModel):
    """
    GroupCreate
    """ # noqa: E501
    id: Annotated[str, Field(strict=True)] = Field(description="Chat ID")
    name: StrictStr = Field(description="Group name")
    type: StrictStr = Field(description="Chat type")
    timestamp: Optional[StrictInt] = Field(default=None, description="Chat timestamp")
    participants: List[Participant] = Field(description="Group participants")
    name_at: Optional[StrictInt] = Field(default=None, description="Group name set timestamp")
    created_at: Optional[StrictInt] = Field(default=None, description="Group creation timestamp")
    created_by: Optional[Annotated[str, Field(strict=True)]] = Field(default=None, description="Contact ID")
    unprocessed_participants: Optional[List[Annotated[str, Field(strict=True)]]] = Field(default=None, description="Сontacts that could not be added to the group")
    __properties: ClassVar[List[str]] = ["id", "name", "type", "timestamp", "participants", "name_at", "created_at", "created_by", "unprocessed_participants"]

    @field_validator('id')
    def id_validate_regular_expression(cls, value):
        """Validates the regular expression"""
        if not re.match(r"^[\d-]{10,31}@[\w\.]{1,}$", value):
            raise ValueError(r"must validate the regular expression /^[\d-]{10,31}@[\w\.]{1,}$/")
        return value

    @field_validator('type')
    def type_validate_enum(cls, value):
        """Validates the enum"""
        if value not in set(['group', 'contact', 'broadcast', 'newsletter', 'unknown']):
            raise ValueError("must be one of enum values ('group', 'contact', 'broadcast', 'newsletter', 'unknown')")
        return value

    @field_validator('created_by')
    def created_by_validate_regular_expression(cls, value):
        """Validates the regular expression"""
        if value is None:
            return value

        if not re.match(r"^([\d]{7,15})?$", value):
            raise ValueError(r"must validate the regular expression /^([\d]{7,15})?$/")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of GroupCreate from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in participants (list)
        _items = []
        if self.participants:
            for _item_participants in self.participants:
                if _item_participants:
                    _items.append(_item_participants.to_dict())
            _dict['participants'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of GroupCreate from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "id": obj.get("id"),
            "name": obj.get("name"),
            "type": obj.get("type"),
            "timestamp": obj.get("timestamp"),
            "participants": [Participant.from_dict(_item) for _item in obj["participants"]] if obj.get("participants") is not None else None,
            "name_at": obj.get("name_at"),
            "created_at": obj.get("created_at"),
            "created_by": obj.get("created_by"),
            "unprocessed_participants": obj.get("unprocessed_participants")
        })
        return _obj


