# coding: utf-8

"""
    Whapi API

    Sending and receiving messages using HTTP requests. Fixed price with no hidden fees, without limits and restrictions. You will be able to send and receive text/media/files/locations/goods/orders/polls messages via WhatsApp in private or group chats. Guides and SDK can be found on our website.

    The version of the OpenAPI document: 1.8.7
    Contact: care@whapi.cloud
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictFloat, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional, Union
from openapi_client.models.channel_status import ChannelStatus
from openapi_client.models.contact import Contact
from typing import Optional, Set
from typing_extensions import Self

class Health(BaseModel):
    """
    The health object contains information about the uptime of the channel and the status of the channel. Sent on event \"channels.post\"
    """ # noqa: E501
    start_at: Union[StrictFloat, StrictInt] = Field(description="Date timestamp when channel started on the server.")
    uptime: Union[StrictFloat, StrictInt] = Field(description="Seconds have passed since the start of the instance.")
    version: Optional[StrictStr] = Field(default=None, description="Channel version")
    device_id: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, description="Current device ID")
    ip: Optional[StrictStr] = Field(default=None, description="Current channel ip-address")
    status: ChannelStatus
    user: Optional[Contact] = None
    __properties: ClassVar[List[str]] = ["start_at", "uptime", "version", "device_id", "ip", "status", "user"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of Health from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of status
        if self.status:
            _dict['status'] = self.status.to_dict()
        # override the default output from pydantic by calling `to_dict()` of user
        if self.user:
            _dict['user'] = self.user.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of Health from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "start_at": obj.get("start_at"),
            "uptime": obj.get("uptime"),
            "version": obj.get("version"),
            "device_id": obj.get("device_id"),
            "ip": obj.get("ip"),
            "status": ChannelStatus.from_dict(obj["status"]) if obj.get("status") is not None else None,
            "user": Contact.from_dict(obj["user"]) if obj.get("user") is not None else None
        })
        return _obj


