# coding: utf-8

"""
    Whapi API

    Sending and receiving messages using HTTP requests. Fixed price with no hidden fees, without limits and restrictions. You will be able to send and receive text/media/files/locations/goods/orders/polls messages via WhatsApp in private or group chats. Guides and SDK can be found on our website.

    The version of the OpenAPI document: 1.8.7
    Contact: care@whapi.cloud
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictFloat, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional, Union
from openapi_client.models.label import Label
from openapi_client.models.message_action import MessageAction
from openapi_client.models.message_content_audio import MessageContentAudio
from openapi_client.models.message_content_buttons import MessageContentButtons
from openapi_client.models.message_content_contact import MessageContentContact
from openapi_client.models.message_content_contacts import MessageContentContacts
from openapi_client.models.message_content_document import MessageContentDocument
from openapi_client.models.message_content_event import MessageContentEvent
from openapi_client.models.message_content_hsm import MessageContentHSM
from openapi_client.models.message_content_image import MessageContentImage
from openapi_client.models.message_content_interactive import MessageContentInteractive
from openapi_client.models.message_content_link_preview import MessageContentLinkPreview
from openapi_client.models.message_content_list import MessageContentList
from openapi_client.models.message_content_live_location import MessageContentLiveLocation
from openapi_client.models.message_content_location import MessageContentLocation
from openapi_client.models.message_content_newsletter_admin_invite import MessageContentNewsletterAdminInvite
from openapi_client.models.message_content_order import MessageContentOrder
from openapi_client.models.message_content_poll import MessageContentPoll
from openapi_client.models.message_content_product import MessageContentProduct
from openapi_client.models.message_content_product_items import MessageContentProductItems
from openapi_client.models.message_content_sticker import MessageContentSticker
from openapi_client.models.message_content_system import MessageContentSystem
from openapi_client.models.message_content_text import MessageContentText
from openapi_client.models.message_content_video import MessageContentVideo
from openapi_client.models.message_context import MessageContext
from openapi_client.models.message_reaction import MessageReaction
from openapi_client.models.message_source import MessageSource
from openapi_client.models.message_type import MessageType
from openapi_client.models.status_enum import StatusEnum
from typing import Optional, Set
from typing_extensions import Self

class Message(BaseModel):
    """
    Message
    """ # noqa: E501
    id: StrictStr = Field(description="Message ID")
    type: MessageType
    subtype: Optional[StrictStr] = Field(default=None, description="Message subtype")
    chat_id: StrictStr = Field(description="Chat ID")
    chat_name: Optional[StrictStr] = Field(default=None, description="Chat name")
    var_from: Optional[StrictStr] = Field(default=None, description="WhatsApp ID of the sender", alias="from")
    from_me: StrictBool = Field(description="Is message from me")
    from_name: Optional[StrictStr] = Field(default=None, description="Pushname of the sender")
    source: Optional[MessageSource] = text
    timestamp: Union[StrictFloat, StrictInt] = Field(description="Message timestamp")
    device_id: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, description="Device ID, if the message was not sent through the app")
    status: Optional[StatusEnum] = None
    text: Optional[MessageContentText] = None
    image: Optional[MessageContentImage] = None
    video: Optional[MessageContentVideo] = None
    short: Optional[MessageContentVideo] = None
    gif: Optional[MessageContentVideo] = None
    audio: Optional[MessageContentAudio] = None
    voice: Optional[MessageContentAudio] = None
    document: Optional[MessageContentDocument] = None
    link_preview: Optional[MessageContentLinkPreview] = None
    sticker: Optional[MessageContentSticker] = None
    location: Optional[MessageContentLocation] = None
    live_location: Optional[MessageContentLiveLocation] = None
    contact: Optional[MessageContentContact] = None
    contact_list: Optional[MessageContentContacts] = None
    interactive: Optional[MessageContentInteractive] = None
    poll: Optional[MessageContentPoll] = None
    hsm: Optional[MessageContentHSM] = None
    system: Optional[MessageContentSystem] = None
    order: Optional[MessageContentOrder] = None
    group_invite: Optional[MessageContentLinkPreview] = None
    newsletter_invite: Optional[MessageContentLinkPreview] = None
    admin_invite: Optional[MessageContentNewsletterAdminInvite] = None
    product: Optional[MessageContentProduct] = None
    catalog: Optional[MessageContentLinkPreview] = None
    product_items: Optional[MessageContentProductItems] = None
    action: Optional[MessageAction] = None
    context: Optional[MessageContext] = None
    event: Optional[MessageContentEvent] = None
    list: Optional[MessageContentList] = None
    buttons: Optional[MessageContentButtons] = None
    reactions: Optional[List[MessageReaction]] = Field(default=None, description="Reactions for message")
    labels: Optional[List[Label]] = Field(default=None, description="Labels associated with message")
    __properties: ClassVar[List[str]] = ["id", "type", "subtype", "chat_id", "chat_name", "from", "from_me", "from_name", "source", "timestamp", "device_id", "status", "text", "image", "video", "short", "gif", "audio", "voice", "document", "link_preview", "sticker", "location", "live_location", "contact", "contact_list", "interactive", "poll", "hsm", "system", "order", "group_invite", "newsletter_invite", "admin_invite", "product", "catalog", "product_items", "action", "context", "event", "list", "buttons", "reactions", "labels"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of Message from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of text
        if self.text:
            _dict['text'] = self.text.to_dict()
        # override the default output from pydantic by calling `to_dict()` of image
        if self.image:
            _dict['image'] = self.image.to_dict()
        # override the default output from pydantic by calling `to_dict()` of video
        if self.video:
            _dict['video'] = self.video.to_dict()
        # override the default output from pydantic by calling `to_dict()` of short
        if self.short:
            _dict['short'] = self.short.to_dict()
        # override the default output from pydantic by calling `to_dict()` of gif
        if self.gif:
            _dict['gif'] = self.gif.to_dict()
        # override the default output from pydantic by calling `to_dict()` of audio
        if self.audio:
            _dict['audio'] = self.audio.to_dict()
        # override the default output from pydantic by calling `to_dict()` of voice
        if self.voice:
            _dict['voice'] = self.voice.to_dict()
        # override the default output from pydantic by calling `to_dict()` of document
        if self.document:
            _dict['document'] = self.document.to_dict()
        # override the default output from pydantic by calling `to_dict()` of link_preview
        if self.link_preview:
            _dict['link_preview'] = self.link_preview.to_dict()
        # override the default output from pydantic by calling `to_dict()` of sticker
        if self.sticker:
            _dict['sticker'] = self.sticker.to_dict()
        # override the default output from pydantic by calling `to_dict()` of location
        if self.location:
            _dict['location'] = self.location.to_dict()
        # override the default output from pydantic by calling `to_dict()` of live_location
        if self.live_location:
            _dict['live_location'] = self.live_location.to_dict()
        # override the default output from pydantic by calling `to_dict()` of contact
        if self.contact:
            _dict['contact'] = self.contact.to_dict()
        # override the default output from pydantic by calling `to_dict()` of contact_list
        if self.contact_list:
            _dict['contact_list'] = self.contact_list.to_dict()
        # override the default output from pydantic by calling `to_dict()` of interactive
        if self.interactive:
            _dict['interactive'] = self.interactive.to_dict()
        # override the default output from pydantic by calling `to_dict()` of poll
        if self.poll:
            _dict['poll'] = self.poll.to_dict()
        # override the default output from pydantic by calling `to_dict()` of hsm
        if self.hsm:
            _dict['hsm'] = self.hsm.to_dict()
        # override the default output from pydantic by calling `to_dict()` of system
        if self.system:
            _dict['system'] = self.system.to_dict()
        # override the default output from pydantic by calling `to_dict()` of order
        if self.order:
            _dict['order'] = self.order.to_dict()
        # override the default output from pydantic by calling `to_dict()` of group_invite
        if self.group_invite:
            _dict['group_invite'] = self.group_invite.to_dict()
        # override the default output from pydantic by calling `to_dict()` of newsletter_invite
        if self.newsletter_invite:
            _dict['newsletter_invite'] = self.newsletter_invite.to_dict()
        # override the default output from pydantic by calling `to_dict()` of admin_invite
        if self.admin_invite:
            _dict['admin_invite'] = self.admin_invite.to_dict()
        # override the default output from pydantic by calling `to_dict()` of product
        if self.product:
            _dict['product'] = self.product.to_dict()
        # override the default output from pydantic by calling `to_dict()` of catalog
        if self.catalog:
            _dict['catalog'] = self.catalog.to_dict()
        # override the default output from pydantic by calling `to_dict()` of product_items
        if self.product_items:
            _dict['product_items'] = self.product_items.to_dict()
        # override the default output from pydantic by calling `to_dict()` of action
        if self.action:
            _dict['action'] = self.action.to_dict()
        # override the default output from pydantic by calling `to_dict()` of context
        if self.context:
            _dict['context'] = self.context.to_dict()
        # override the default output from pydantic by calling `to_dict()` of event
        if self.event:
            _dict['event'] = self.event.to_dict()
        # override the default output from pydantic by calling `to_dict()` of list
        if self.list:
            _dict['list'] = self.list.to_dict()
        # override the default output from pydantic by calling `to_dict()` of buttons
        if self.buttons:
            _dict['buttons'] = self.buttons.to_dict()
        # override the default output from pydantic by calling `to_dict()` of each item in reactions (list)
        _items = []
        if self.reactions:
            for _item_reactions in self.reactions:
                if _item_reactions:
                    _items.append(_item_reactions.to_dict())
            _dict['reactions'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in labels (list)
        _items = []
        if self.labels:
            for _item_labels in self.labels:
                if _item_labels:
                    _items.append(_item_labels.to_dict())
            _dict['labels'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of Message from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "id": obj.get("id"),
            "type": obj.get("type") if obj.get("type") is not None else MessageType.TEXT,
            "subtype": obj.get("subtype"),
            "chat_id": obj.get("chat_id"),
            "chat_name": obj.get("chat_name"),
            "from": obj.get("from"),
            "from_me": obj.get("from_me"),
            "from_name": obj.get("from_name"),
            "source": obj.get("source") if obj.get("source") is not None else text,
            "timestamp": obj.get("timestamp"),
            "device_id": obj.get("device_id"),
            "status": obj.get("status"),
            "text": MessageContentText.from_dict(obj["text"]) if obj.get("text") is not None else None,
            "image": MessageContentImage.from_dict(obj["image"]) if obj.get("image") is not None else None,
            "video": MessageContentVideo.from_dict(obj["video"]) if obj.get("video") is not None else None,
            "short": MessageContentVideo.from_dict(obj["short"]) if obj.get("short") is not None else None,
            "gif": MessageContentVideo.from_dict(obj["gif"]) if obj.get("gif") is not None else None,
            "audio": MessageContentAudio.from_dict(obj["audio"]) if obj.get("audio") is not None else None,
            "voice": MessageContentAudio.from_dict(obj["voice"]) if obj.get("voice") is not None else None,
            "document": MessageContentDocument.from_dict(obj["document"]) if obj.get("document") is not None else None,
            "link_preview": MessageContentLinkPreview.from_dict(obj["link_preview"]) if obj.get("link_preview") is not None else None,
            "sticker": MessageContentSticker.from_dict(obj["sticker"]) if obj.get("sticker") is not None else None,
            "location": MessageContentLocation.from_dict(obj["location"]) if obj.get("location") is not None else None,
            "live_location": MessageContentLiveLocation.from_dict(obj["live_location"]) if obj.get("live_location") is not None else None,
            "contact": MessageContentContact.from_dict(obj["contact"]) if obj.get("contact") is not None else None,
            "contact_list": MessageContentContacts.from_dict(obj["contact_list"]) if obj.get("contact_list") is not None else None,
            "interactive": MessageContentInteractive.from_dict(obj["interactive"]) if obj.get("interactive") is not None else None,
            "poll": MessageContentPoll.from_dict(obj["poll"]) if obj.get("poll") is not None else None,
            "hsm": MessageContentHSM.from_dict(obj["hsm"]) if obj.get("hsm") is not None else None,
            "system": MessageContentSystem.from_dict(obj["system"]) if obj.get("system") is not None else None,
            "order": MessageContentOrder.from_dict(obj["order"]) if obj.get("order") is not None else None,
            "group_invite": MessageContentLinkPreview.from_dict(obj["group_invite"]) if obj.get("group_invite") is not None else None,
            "newsletter_invite": MessageContentLinkPreview.from_dict(obj["newsletter_invite"]) if obj.get("newsletter_invite") is not None else None,
            "admin_invite": MessageContentNewsletterAdminInvite.from_dict(obj["admin_invite"]) if obj.get("admin_invite") is not None else None,
            "product": MessageContentProduct.from_dict(obj["product"]) if obj.get("product") is not None else None,
            "catalog": MessageContentLinkPreview.from_dict(obj["catalog"]) if obj.get("catalog") is not None else None,
            "product_items": MessageContentProductItems.from_dict(obj["product_items"]) if obj.get("product_items") is not None else None,
            "action": MessageAction.from_dict(obj["action"]) if obj.get("action") is not None else None,
            "context": MessageContext.from_dict(obj["context"]) if obj.get("context") is not None else None,
            "event": MessageContentEvent.from_dict(obj["event"]) if obj.get("event") is not None else None,
            "list": MessageContentList.from_dict(obj["list"]) if obj.get("list") is not None else None,
            "buttons": MessageContentButtons.from_dict(obj["buttons"]) if obj.get("buttons") is not None else None,
            "reactions": [MessageReaction.from_dict(_item) for _item in obj["reactions"]] if obj.get("reactions") is not None else None,
            "labels": [Label.from_dict(_item) for _item in obj["labels"]] if obj.get("labels") is not None else None
        })
        return _obj


