# coding: utf-8

"""
    Whapi API

    Sending and receiving messages using HTTP requests. Fixed price with no hidden fees, without limits and restrictions. You will be able to send and receive text/media/files/locations/goods/orders/polls messages via WhatsApp in private or group chats. Guides and SDK can be found on our website.

    The version of the OpenAPI document: 1.8.7
    Contact: care@whapi.cloud
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictInt, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from openapi_client.models.event_response import EventResponse
from openapi_client.models.message_content import MessageContent
from openapi_client.models.message_type import MessageType
from typing import Optional, Set
from typing_extensions import Self

class MessageAction(BaseModel):
    """
    MessageAction
    """ # noqa: E501
    target: Optional[StrictStr] = Field(default=None, description="Target message ID or chat ID")
    type: StrictStr = Field(description="Type of action")
    emoji: Optional[StrictStr] = Field(default=None, description="Action emoji for reaction")
    ephemeral: Optional[StrictInt] = Field(default=None, description="Ephemeral message duration")
    edited_type: Optional[MessageType] = MessageType.TEXT
    edited_content: Optional[MessageContent] = None
    votes: Optional[List[StrictStr]] = Field(default=None, description="List of poll options")
    comment: Optional[StrictStr] = Field(default=None, description="Comment")
    event_response: Optional[EventResponse] = None
    __properties: ClassVar[List[str]] = ["target", "type", "emoji", "ephemeral", "edited_type", "edited_content", "votes", "comment", "event_response"]

    @field_validator('type')
    def type_validate_enum(cls, value):
        """Validates the enum"""
        if value not in set(['edited', 'edit', 'delete', 'reaction', 'ephemeral', 'vote', 'comment', 'event_response']):
            raise ValueError("must be one of enum values ('edited', 'edit', 'delete', 'reaction', 'ephemeral', 'vote', 'comment', 'event_response')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of MessageAction from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of edited_content
        if self.edited_content:
            _dict['edited_content'] = self.edited_content.to_dict()
        # override the default output from pydantic by calling `to_dict()` of event_response
        if self.event_response:
            _dict['event_response'] = self.event_response.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of MessageAction from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "target": obj.get("target"),
            "type": obj.get("type"),
            "emoji": obj.get("emoji"),
            "ephemeral": obj.get("ephemeral"),
            "edited_type": obj.get("edited_type") if obj.get("edited_type") is not None else MessageType.TEXT,
            "edited_content": MessageContent.from_dict(obj["edited_content"]) if obj.get("edited_content") is not None else None,
            "votes": obj.get("votes"),
            "comment": obj.get("comment"),
            "event_response": EventResponse.from_dict(obj["event_response"]) if obj.get("event_response") is not None else None
        })
        return _obj


