# coding: utf-8

"""
    Whapi API

    Sending and receiving messages using HTTP requests. Fixed price with no hidden fees, without limits and restrictions. You will be able to send and receive text/media/files/locations/goods/orders/polls messages via WhatsApp in private or group chats. Guides and SDK can be found on our website.

    The version of the OpenAPI document: 1.8.7
    Contact: care@whapi.cloud
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import json
import pprint
from pydantic import BaseModel, ConfigDict, Field, StrictStr, ValidationError, field_validator
from typing import Any, List, Optional
from openapi_client.models.message_content_audio import MessageContentAudio
from openapi_client.models.message_content_contact import MessageContentContact
from openapi_client.models.message_content_contacts import MessageContentContacts
from openapi_client.models.message_content_document import MessageContentDocument
from openapi_client.models.message_content_image import MessageContentImage
from openapi_client.models.message_content_interactive import MessageContentInteractive
from openapi_client.models.message_content_link_preview import MessageContentLinkPreview
from openapi_client.models.message_content_live_location import MessageContentLiveLocation
from openapi_client.models.message_content_location import MessageContentLocation
from openapi_client.models.message_content_newsletter_admin_invite import MessageContentNewsletterAdminInvite
from openapi_client.models.message_content_poll import MessageContentPoll
from openapi_client.models.message_content_product import MessageContentProduct
from openapi_client.models.message_content_reply import MessageContentReply
from openapi_client.models.message_content_sticker import MessageContentSticker
from openapi_client.models.message_content_text import MessageContentText
from openapi_client.models.message_content_video import MessageContentVideo
from pydantic import StrictStr, Field
from typing import Union, List, Set, Optional, Dict
from typing_extensions import Literal, Self

MESSAGECONTENT_ONE_OF_SCHEMAS = ["MessageContentAudio", "MessageContentContact", "MessageContentContacts", "MessageContentDocument", "MessageContentImage", "MessageContentInteractive", "MessageContentLinkPreview", "MessageContentLiveLocation", "MessageContentLocation", "MessageContentNewsletterAdminInvite", "MessageContentPoll", "MessageContentProduct", "MessageContentReply", "MessageContentSticker", "MessageContentText", "MessageContentVideo"]

class MessageContent(BaseModel):
    """
    MessageContent
    """
    # data type: MessageContentText
    oneof_schema_1_validator: Optional[MessageContentText] = None
    # data type: MessageContentImage
    oneof_schema_2_validator: Optional[MessageContentImage] = None
    # data type: MessageContentVideo
    oneof_schema_3_validator: Optional[MessageContentVideo] = None
    # data type: MessageContentAudio
    oneof_schema_4_validator: Optional[MessageContentAudio] = None
    # data type: MessageContentDocument
    oneof_schema_5_validator: Optional[MessageContentDocument] = None
    # data type: MessageContentLinkPreview
    oneof_schema_6_validator: Optional[MessageContentLinkPreview] = None
    # data type: MessageContentNewsletterAdminInvite
    oneof_schema_7_validator: Optional[MessageContentNewsletterAdminInvite] = None
    # data type: MessageContentProduct
    oneof_schema_8_validator: Optional[MessageContentProduct] = None
    # data type: MessageContentSticker
    oneof_schema_9_validator: Optional[MessageContentSticker] = None
    # data type: MessageContentLocation
    oneof_schema_10_validator: Optional[MessageContentLocation] = None
    # data type: MessageContentLiveLocation
    oneof_schema_11_validator: Optional[MessageContentLiveLocation] = None
    # data type: MessageContentContact
    oneof_schema_12_validator: Optional[MessageContentContact] = None
    # data type: MessageContentContacts
    oneof_schema_13_validator: Optional[MessageContentContacts] = None
    # data type: MessageContentInteractive
    oneof_schema_14_validator: Optional[MessageContentInteractive] = None
    # data type: MessageContentPoll
    oneof_schema_15_validator: Optional[MessageContentPoll] = None
    # data type: MessageContentReply
    oneof_schema_16_validator: Optional[MessageContentReply] = None
    actual_instance: Optional[Union[MessageContentAudio, MessageContentContact, MessageContentContacts, MessageContentDocument, MessageContentImage, MessageContentInteractive, MessageContentLinkPreview, MessageContentLiveLocation, MessageContentLocation, MessageContentNewsletterAdminInvite, MessageContentPoll, MessageContentProduct, MessageContentReply, MessageContentSticker, MessageContentText, MessageContentVideo]] = None
    one_of_schemas: Set[str] = { "MessageContentAudio", "MessageContentContact", "MessageContentContacts", "MessageContentDocument", "MessageContentImage", "MessageContentInteractive", "MessageContentLinkPreview", "MessageContentLiveLocation", "MessageContentLocation", "MessageContentNewsletterAdminInvite", "MessageContentPoll", "MessageContentProduct", "MessageContentReply", "MessageContentSticker", "MessageContentText", "MessageContentVideo" }

    model_config = ConfigDict(
        validate_assignment=True,
        protected_namespaces=(),
    )


    def __init__(self, *args, **kwargs) -> None:
        if args:
            if len(args) > 1:
                raise ValueError("If a position argument is used, only 1 is allowed to set `actual_instance`")
            if kwargs:
                raise ValueError("If a position argument is used, keyword arguments cannot be used.")
            super().__init__(actual_instance=args[0])
        else:
            super().__init__(**kwargs)

    @field_validator('actual_instance')
    def actual_instance_must_validate_oneof(cls, v):
        instance = MessageContent.model_construct()
        error_messages = []
        match = 0
        # validate data type: MessageContentText
        if not isinstance(v, MessageContentText):
            error_messages.append(f"Error! Input type `{type(v)}` is not `MessageContentText`")
        else:
            match += 1
        # validate data type: MessageContentImage
        if not isinstance(v, MessageContentImage):
            error_messages.append(f"Error! Input type `{type(v)}` is not `MessageContentImage`")
        else:
            match += 1
        # validate data type: MessageContentVideo
        if not isinstance(v, MessageContentVideo):
            error_messages.append(f"Error! Input type `{type(v)}` is not `MessageContentVideo`")
        else:
            match += 1
        # validate data type: MessageContentAudio
        if not isinstance(v, MessageContentAudio):
            error_messages.append(f"Error! Input type `{type(v)}` is not `MessageContentAudio`")
        else:
            match += 1
        # validate data type: MessageContentDocument
        if not isinstance(v, MessageContentDocument):
            error_messages.append(f"Error! Input type `{type(v)}` is not `MessageContentDocument`")
        else:
            match += 1
        # validate data type: MessageContentLinkPreview
        if not isinstance(v, MessageContentLinkPreview):
            error_messages.append(f"Error! Input type `{type(v)}` is not `MessageContentLinkPreview`")
        else:
            match += 1
        # validate data type: MessageContentNewsletterAdminInvite
        if not isinstance(v, MessageContentNewsletterAdminInvite):
            error_messages.append(f"Error! Input type `{type(v)}` is not `MessageContentNewsletterAdminInvite`")
        else:
            match += 1
        # validate data type: MessageContentProduct
        if not isinstance(v, MessageContentProduct):
            error_messages.append(f"Error! Input type `{type(v)}` is not `MessageContentProduct`")
        else:
            match += 1
        # validate data type: MessageContentSticker
        if not isinstance(v, MessageContentSticker):
            error_messages.append(f"Error! Input type `{type(v)}` is not `MessageContentSticker`")
        else:
            match += 1
        # validate data type: MessageContentLocation
        if not isinstance(v, MessageContentLocation):
            error_messages.append(f"Error! Input type `{type(v)}` is not `MessageContentLocation`")
        else:
            match += 1
        # validate data type: MessageContentLiveLocation
        if not isinstance(v, MessageContentLiveLocation):
            error_messages.append(f"Error! Input type `{type(v)}` is not `MessageContentLiveLocation`")
        else:
            match += 1
        # validate data type: MessageContentContact
        if not isinstance(v, MessageContentContact):
            error_messages.append(f"Error! Input type `{type(v)}` is not `MessageContentContact`")
        else:
            match += 1
        # validate data type: MessageContentContacts
        if not isinstance(v, MessageContentContacts):
            error_messages.append(f"Error! Input type `{type(v)}` is not `MessageContentContacts`")
        else:
            match += 1
        # validate data type: MessageContentInteractive
        if not isinstance(v, MessageContentInteractive):
            error_messages.append(f"Error! Input type `{type(v)}` is not `MessageContentInteractive`")
        else:
            match += 1
        # validate data type: MessageContentPoll
        if not isinstance(v, MessageContentPoll):
            error_messages.append(f"Error! Input type `{type(v)}` is not `MessageContentPoll`")
        else:
            match += 1
        # validate data type: MessageContentReply
        if not isinstance(v, MessageContentReply):
            error_messages.append(f"Error! Input type `{type(v)}` is not `MessageContentReply`")
        else:
            match += 1
        if match > 1:
            # more than 1 match
            raise ValueError("Multiple matches found when setting `actual_instance` in MessageContent with oneOf schemas: MessageContentAudio, MessageContentContact, MessageContentContacts, MessageContentDocument, MessageContentImage, MessageContentInteractive, MessageContentLinkPreview, MessageContentLiveLocation, MessageContentLocation, MessageContentNewsletterAdminInvite, MessageContentPoll, MessageContentProduct, MessageContentReply, MessageContentSticker, MessageContentText, MessageContentVideo. Details: " + ", ".join(error_messages))
        elif match == 0:
            # no match
            raise ValueError("No match found when setting `actual_instance` in MessageContent with oneOf schemas: MessageContentAudio, MessageContentContact, MessageContentContacts, MessageContentDocument, MessageContentImage, MessageContentInteractive, MessageContentLinkPreview, MessageContentLiveLocation, MessageContentLocation, MessageContentNewsletterAdminInvite, MessageContentPoll, MessageContentProduct, MessageContentReply, MessageContentSticker, MessageContentText, MessageContentVideo. Details: " + ", ".join(error_messages))
        else:
            return v

    @classmethod
    def from_dict(cls, obj: Union[str, Dict[str, Any]]) -> Self:
        return cls.from_json(json.dumps(obj))

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Returns the object represented by the json string"""
        instance = cls.model_construct()
        error_messages = []
        match = 0

        # deserialize data into MessageContentText
        try:
            instance.actual_instance = MessageContentText.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into MessageContentImage
        try:
            instance.actual_instance = MessageContentImage.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into MessageContentVideo
        try:
            instance.actual_instance = MessageContentVideo.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into MessageContentAudio
        try:
            instance.actual_instance = MessageContentAudio.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into MessageContentDocument
        try:
            instance.actual_instance = MessageContentDocument.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into MessageContentLinkPreview
        try:
            instance.actual_instance = MessageContentLinkPreview.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into MessageContentNewsletterAdminInvite
        try:
            instance.actual_instance = MessageContentNewsletterAdminInvite.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into MessageContentProduct
        try:
            instance.actual_instance = MessageContentProduct.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into MessageContentSticker
        try:
            instance.actual_instance = MessageContentSticker.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into MessageContentLocation
        try:
            instance.actual_instance = MessageContentLocation.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into MessageContentLiveLocation
        try:
            instance.actual_instance = MessageContentLiveLocation.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into MessageContentContact
        try:
            instance.actual_instance = MessageContentContact.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into MessageContentContacts
        try:
            instance.actual_instance = MessageContentContacts.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into MessageContentInteractive
        try:
            instance.actual_instance = MessageContentInteractive.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into MessageContentPoll
        try:
            instance.actual_instance = MessageContentPoll.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into MessageContentReply
        try:
            instance.actual_instance = MessageContentReply.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))

        if match > 1:
            # more than 1 match
            raise ValueError("Multiple matches found when deserializing the JSON string into MessageContent with oneOf schemas: MessageContentAudio, MessageContentContact, MessageContentContacts, MessageContentDocument, MessageContentImage, MessageContentInteractive, MessageContentLinkPreview, MessageContentLiveLocation, MessageContentLocation, MessageContentNewsletterAdminInvite, MessageContentPoll, MessageContentProduct, MessageContentReply, MessageContentSticker, MessageContentText, MessageContentVideo. Details: " + ", ".join(error_messages))
        elif match == 0:
            # no match
            raise ValueError("No match found when deserializing the JSON string into MessageContent with oneOf schemas: MessageContentAudio, MessageContentContact, MessageContentContacts, MessageContentDocument, MessageContentImage, MessageContentInteractive, MessageContentLinkPreview, MessageContentLiveLocation, MessageContentLocation, MessageContentNewsletterAdminInvite, MessageContentPoll, MessageContentProduct, MessageContentReply, MessageContentSticker, MessageContentText, MessageContentVideo. Details: " + ", ".join(error_messages))
        else:
            return instance

    def to_json(self) -> str:
        """Returns the JSON representation of the actual instance"""
        if self.actual_instance is None:
            return "null"

        if hasattr(self.actual_instance, "to_json") and callable(self.actual_instance.to_json):
            return self.actual_instance.to_json()
        else:
            return json.dumps(self.actual_instance)

    def to_dict(self) -> Optional[Union[Dict[str, Any], MessageContentAudio, MessageContentContact, MessageContentContacts, MessageContentDocument, MessageContentImage, MessageContentInteractive, MessageContentLinkPreview, MessageContentLiveLocation, MessageContentLocation, MessageContentNewsletterAdminInvite, MessageContentPoll, MessageContentProduct, MessageContentReply, MessageContentSticker, MessageContentText, MessageContentVideo]]:
        """Returns the dict representation of the actual instance"""
        if self.actual_instance is None:
            return None

        if hasattr(self.actual_instance, "to_dict") and callable(self.actual_instance.to_dict):
            return self.actual_instance.to_dict()
        else:
            # primitive type
            return self.actual_instance

    def to_str(self) -> str:
        """Returns the string representation of the actual instance"""
        return pprint.pformat(self.model_dump())


