# coding: utf-8

"""
    Whapi API

    Sending and receiving messages using HTTP requests. Fixed price with no hidden fees, without limits and restrictions. You will be able to send and receive text/media/files/locations/goods/orders/polls messages via WhatsApp in private or group chats. Guides and SDK can be found on our website.

    The version of the OpenAPI document: 1.8.7
    Contact: care@whapi.cloud
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictFloat, StrictInt, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional, Union
from typing_extensions import Annotated
from openapi_client.models.interactive_action import InteractiveAction
from openapi_client.models.interactive_type import InteractiveType
from openapi_client.models.message_props_interactive_body import MessagePropsInteractiveBody
from openapi_client.models.message_props_interactive_footer import MessagePropsInteractiveFooter
from openapi_client.models.message_props_interactive_header import MessagePropsInteractiveHeader
from typing import Optional, Set
from typing_extensions import Self

class MessageContentInteractive(BaseModel):
    """
    MessageContentInteractive
    """ # noqa: E501
    header: Optional[MessagePropsInteractiveHeader] = None
    body: Optional[MessagePropsInteractiveBody] = None
    footer: Optional[MessagePropsInteractiveFooter] = None
    action: InteractiveAction
    type: Optional[InteractiveType] = InteractiveType.BUTTON
    id: Annotated[str, Field(strict=True)] = Field(description="Media ID")
    link: Optional[StrictStr] = Field(default=None, description="Optional. Link to media")
    mime_type: StrictStr = Field(description="Mime type of media")
    file_size: StrictInt = Field(description="File size in bytes")
    file_name: Optional[StrictStr] = Field(default=None, description="Optional. File name")
    sha256: Optional[StrictStr] = Field(default=None, description="Checksum")
    timestamp: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, description="Created at")
    view_once: Optional[StrictBool] = Field(default=None, description="Is view once")
    __properties: ClassVar[List[str]] = ["header", "body", "footer", "action", "type", "id", "link", "mime_type", "file_size", "file_name", "sha256", "timestamp", "view_once"]

    @field_validator('id')
    def id_validate_regular_expression(cls, value):
        """Validates the regular expression"""
        if not re.match(r"^[a-zA-Z0-9]+-[0-9a-fA-F-]+$", value):
            raise ValueError(r"must validate the regular expression /^[a-zA-Z0-9]+-[0-9a-fA-F-]+$/")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of MessageContentInteractive from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of header
        if self.header:
            _dict['header'] = self.header.to_dict()
        # override the default output from pydantic by calling `to_dict()` of body
        if self.body:
            _dict['body'] = self.body.to_dict()
        # override the default output from pydantic by calling `to_dict()` of footer
        if self.footer:
            _dict['footer'] = self.footer.to_dict()
        # override the default output from pydantic by calling `to_dict()` of action
        if self.action:
            _dict['action'] = self.action.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of MessageContentInteractive from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "header": MessagePropsInteractiveHeader.from_dict(obj["header"]) if obj.get("header") is not None else None,
            "body": MessagePropsInteractiveBody.from_dict(obj["body"]) if obj.get("body") is not None else None,
            "footer": MessagePropsInteractiveFooter.from_dict(obj["footer"]) if obj.get("footer") is not None else None,
            "action": InteractiveAction.from_dict(obj["action"]) if obj.get("action") is not None else None,
            "type": obj.get("type") if obj.get("type") is not None else InteractiveType.BUTTON,
            "id": obj.get("id"),
            "link": obj.get("link"),
            "mime_type": obj.get("mime_type"),
            "file_size": obj.get("file_size"),
            "file_name": obj.get("file_name"),
            "sha256": obj.get("sha256"),
            "timestamp": obj.get("timestamp"),
            "view_once": obj.get("view_once")
        })
        return _obj


