# coding: utf-8

"""
    Whapi API

    Sending and receiving messages using HTTP requests. Fixed price with no hidden fees, without limits and restrictions. You will be able to send and receive text/media/files/locations/goods/orders/polls messages via WhatsApp in private or group chats. Guides and SDK can be found on our website.

    The version of the OpenAPI document: 1.8.7
    Contact: care@whapi.cloud
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from typing_extensions import Annotated
from typing import Optional, Set
from typing_extensions import Self

class MessageContentLinkPreview(BaseModel):
    """
    MessageContentLinkPreview
    """ # noqa: E501
    body: StrictStr = Field(description="Message text")
    title: StrictStr = Field(description="Title of the link")
    description: Optional[StrictStr] = Field(default=None, description="Description of the link")
    canonical: Optional[StrictStr] = Field(default=None, description="Canonical URL of the link (for example, if the link is shortened)")
    preview: Optional[StrictStr] = Field(default=None, description="Base64 encoded image for mini version link preview. In JPEG format")
    view_once: Optional[StrictBool] = Field(default=None, description="Is view once")
    url: Optional[StrictStr] = Field(default=None, description="URL of the link")
    id: Optional[Annotated[str, Field(strict=True)]] = Field(default=None, description="Media ID")
    link: Optional[StrictStr] = Field(default=None, description="Optional. Link to media")
    sha256: Optional[StrictStr] = Field(default=None, description="Checksum")
    catalog_id: Optional[Annotated[str, Field(strict=True)]] = Field(default=None, description="Contact ID")
    newsletter_id: Optional[Annotated[str, Field(strict=True)]] = Field(default=None, description="Newsletter ID")
    invite_code: Optional[Annotated[str, Field(strict=True)]] = Field(default=None, description="Invite code")
    __properties: ClassVar[List[str]] = ["body", "title", "description", "canonical", "preview", "view_once", "url", "id", "link", "sha256", "catalog_id", "newsletter_id", "invite_code"]

    @field_validator('id')
    def id_validate_regular_expression(cls, value):
        """Validates the regular expression"""
        if value is None:
            return value

        if not re.match(r"^[a-zA-Z0-9]+-[0-9a-fA-F-]+$", value):
            raise ValueError(r"must validate the regular expression /^[a-zA-Z0-9]+-[0-9a-fA-F-]+$/")
        return value

    @field_validator('catalog_id')
    def catalog_id_validate_regular_expression(cls, value):
        """Validates the regular expression"""
        if value is None:
            return value

        if not re.match(r"^([\d]{7,15})?$", value):
            raise ValueError(r"must validate the regular expression /^([\d]{7,15})?$/")
        return value

    @field_validator('newsletter_id')
    def newsletter_id_validate_regular_expression(cls, value):
        """Validates the regular expression"""
        if value is None:
            return value

        if not re.match(r"^[\d]{10,18}@newsletter$", value):
            raise ValueError(r"must validate the regular expression /^[\d]{10,18}@newsletter$/")
        return value

    @field_validator('invite_code')
    def invite_code_validate_regular_expression(cls, value):
        """Validates the regular expression"""
        if value is None:
            return value

        if not re.match(r"^[A-Za-z0-9]{22}$", value):
            raise ValueError(r"must validate the regular expression /^[A-Za-z0-9]{22}$/")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of MessageContentLinkPreview from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of MessageContentLinkPreview from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "body": obj.get("body"),
            "title": obj.get("title"),
            "description": obj.get("description"),
            "canonical": obj.get("canonical"),
            "preview": obj.get("preview"),
            "view_once": obj.get("view_once"),
            "url": obj.get("url"),
            "id": obj.get("id"),
            "link": obj.get("link"),
            "sha256": obj.get("sha256"),
            "catalog_id": obj.get("catalog_id"),
            "newsletter_id": obj.get("newsletter_id"),
            "invite_code": obj.get("invite_code")
        })
        return _obj


