# coding: utf-8

"""
    Whapi API

    Sending and receiving messages using HTTP requests. Fixed price with no hidden fees, without limits and restrictions. You will be able to send and receive text/media/files/locations/goods/orders/polls messages via WhatsApp in private or group chats. Guides and SDK can be found on our website.

    The version of the OpenAPI document: 1.8.7
    Contact: care@whapi.cloud
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictFloat, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional, Union
from typing import Optional, Set
from typing_extensions import Self

class MessageContentLiveLocation(BaseModel):
    """
    MessageContentLiveLocation
    """ # noqa: E501
    view_once: Optional[StrictBool] = Field(default=None, description="Is view once")
    latitude: Union[StrictFloat, StrictInt] = Field(description="Latitude of live location being sent")
    longitude: Union[StrictFloat, StrictInt] = Field(description="Longitude of live location being sent")
    accuracy: Optional[StrictInt] = Field(default=None, description="Accuracy of the live location in meters")
    speed: Optional[StrictInt] = Field(default=None, description="Speed of the live location in meters per second")
    degrees: Optional[StrictInt] = Field(default=None, description="Degrees clockwise from true north")
    caption: Optional[StrictStr] = Field(default=None, description="Optional. Text caption under the live location")
    sequence_number: Optional[StrictInt] = Field(default=None, description="Optional. Sequence number of the live location for event tracking")
    time_offset: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, description="Optional. Time offset of the live location")
    preview: Optional[StrictStr] = Field(default=None, description="Optional. Base64 encoded preview of the media. In JPEG format.")
    __properties: ClassVar[List[str]] = ["view_once", "latitude", "longitude", "accuracy", "speed", "degrees", "caption", "sequence_number", "time_offset", "preview"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of MessageContentLiveLocation from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of MessageContentLiveLocation from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "view_once": obj.get("view_once"),
            "latitude": obj.get("latitude"),
            "longitude": obj.get("longitude"),
            "accuracy": obj.get("accuracy"),
            "speed": obj.get("speed"),
            "degrees": obj.get("degrees"),
            "caption": obj.get("caption"),
            "sequence_number": obj.get("sequence_number"),
            "time_offset": obj.get("time_offset"),
            "preview": obj.get("preview")
        })
        return _obj


