# coding: utf-8

"""
    Whapi API

    Sending and receiving messages using HTTP requests. Fixed price with no hidden fees, without limits and restrictions. You will be able to send and receive text/media/files/locations/goods/orders/polls messages via WhatsApp in private or group chats. Guides and SDK can be found on our website.

    The version of the OpenAPI document: 1.8.7
    Contact: care@whapi.cloud
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing_extensions import Annotated
from openapi_client.models.poll_results import PollResults
from typing import Optional, Set
from typing_extensions import Self

class MessageContentPoll(BaseModel):
    """
    MessageContentPoll
    """ # noqa: E501
    title: StrictStr = Field(description="Title of poll")
    options: Annotated[List[StrictStr], Field(min_length=2, max_length=12)] = Field(description="Options of poll")
    vote_limit: Optional[StrictInt] = Field(default=None, description="Number of selectable options in poll (1 - can choose only one option, 0 - any number of options)")
    total: Optional[StrictInt] = Field(default=None, description="Total count of selected options")
    view_once: Optional[StrictBool] = Field(default=None, description="Is view once")
    results: Optional[List[PollResults]] = None
    __properties: ClassVar[List[str]] = ["title", "options", "vote_limit", "total", "view_once", "results"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of MessageContentPoll from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in results (list)
        _items = []
        if self.results:
            for _item_results in self.results:
                if _item_results:
                    _items.append(_item_results.to_dict())
            _dict['results'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of MessageContentPoll from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "title": obj.get("title"),
            "options": obj.get("options"),
            "vote_limit": obj.get("vote_limit"),
            "total": obj.get("total"),
            "view_once": obj.get("view_once"),
            "results": [PollResults.from_dict(_item) for _item in obj["results"]] if obj.get("results") is not None else None
        })
        return _obj


