# coding: utf-8

"""
    Whapi API

    Sending and receiving messages using HTTP requests. Fixed price with no hidden fees, without limits and restrictions. You will be able to send and receive text/media/files/locations/goods/orders/polls messages via WhatsApp in private or group chats. Guides and SDK can be found on our website.

    The version of the OpenAPI document: 1.8.7
    Contact: care@whapi.cloud
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from openapi_client.models.buttons_reply import ButtonsReply
from openapi_client.models.list_reply import ListReply
from typing import Optional, Set
from typing_extensions import Self

class MessageContentReply(BaseModel):
    """
    MessageContentReply
    """ # noqa: E501
    type: Optional[StrictStr] = Field(default=None, description="Type of message content")
    list_reply: Optional[ListReply] = None
    buttons_reply: Optional[ButtonsReply] = None
    __properties: ClassVar[List[str]] = ["type", "list_reply", "buttons_reply"]

    @field_validator('type')
    def type_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(['list_reply', 'buttons_reply']):
            raise ValueError("must be one of enum values ('list_reply', 'buttons_reply')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of MessageContentReply from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of list_reply
        if self.list_reply:
            _dict['list_reply'] = self.list_reply.to_dict()
        # override the default output from pydantic by calling `to_dict()` of buttons_reply
        if self.buttons_reply:
            _dict['buttons_reply'] = self.buttons_reply.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of MessageContentReply from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "type": obj.get("type"),
            "list_reply": ListReply.from_dict(obj["list_reply"]) if obj.get("list_reply") is not None else None,
            "buttons_reply": ButtonsReply.from_dict(obj["buttons_reply"]) if obj.get("buttons_reply") is not None else None
        })
        return _obj


