# coding: utf-8

"""
    Whapi API

    Sending and receiving messages using HTTP requests. Fixed price with no hidden fees, without limits and restrictions. You will be able to send and receive text/media/files/locations/goods/orders/polls messages via WhatsApp in private or group chats. Guides and SDK can be found on our website.

    The version of the OpenAPI document: 1.8.7
    Contact: care@whapi.cloud
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictFloat, StrictInt, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional, Union
from typing_extensions import Annotated
from typing import Optional, Set
from typing_extensions import Self

class MessageContentSticker(BaseModel):
    """
    MessageContentSticker
    """ # noqa: E501
    id: Annotated[str, Field(strict=True)] = Field(description="Media ID")
    link: Optional[StrictStr] = Field(default=None, description="Optional. Link to media")
    mime_type: StrictStr = Field(description="Mime type of media")
    file_size: StrictInt = Field(description="File size in bytes")
    file_name: Optional[StrictStr] = Field(default=None, description="Optional. File name")
    sha256: Optional[StrictStr] = Field(default=None, description="Checksum")
    timestamp: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, description="Created at")
    animated: Optional[StrictBool] = Field(default=None, description="Optional. For stickers, this field indicates whether the sticker is animated.")
    width: Optional[StrictInt] = Field(default=None, description="Width of the media in pixels")
    height: Optional[StrictInt] = Field(default=None, description="Height of the media in pixels")
    view_once: Optional[StrictBool] = Field(default=None, description="Is view once")
    preview: Optional[StrictStr] = Field(default=None, description="Optional. Base64 encoded preview of the media. In PNG format.")
    __properties: ClassVar[List[str]] = ["id", "link", "mime_type", "file_size", "file_name", "sha256", "timestamp", "animated", "width", "height", "view_once", "preview"]

    @field_validator('id')
    def id_validate_regular_expression(cls, value):
        """Validates the regular expression"""
        if not re.match(r"^[a-zA-Z0-9]+-[0-9a-fA-F-]+$", value):
            raise ValueError(r"must validate the regular expression /^[a-zA-Z0-9]+-[0-9a-fA-F-]+$/")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of MessageContentSticker from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of MessageContentSticker from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "id": obj.get("id"),
            "link": obj.get("link"),
            "mime_type": obj.get("mime_type"),
            "file_size": obj.get("file_size"),
            "file_name": obj.get("file_name"),
            "sha256": obj.get("sha256"),
            "timestamp": obj.get("timestamp"),
            "animated": obj.get("animated"),
            "width": obj.get("width"),
            "height": obj.get("height"),
            "view_once": obj.get("view_once"),
            "preview": obj.get("preview")
        })
        return _obj


