# coding: utf-8

"""
    Whapi API

    Sending and receiving messages using HTTP requests. Fixed price with no hidden fees, without limits and restrictions. You will be able to send and receive text/media/files/locations/goods/orders/polls messages via WhatsApp in private or group chats. Guides and SDK can be found on our website.

    The version of the OpenAPI document: 1.8.7
    Contact: care@whapi.cloud
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from openapi_client.models.message_content import MessageContent
from openapi_client.models.message_context_ad import MessageContextAD
from openapi_client.models.message_context_conversion import MessageContextConversion
from openapi_client.models.message_type import MessageType
from typing import Optional, Set
from typing_extensions import Self

class MessageContext(BaseModel):
    """
    
    """ # noqa: E501
    forwarded: Optional[StrictBool] = Field(default=None, description="Is forwarding message")
    forwarding_score: Optional[StrictInt] = Field(default=None, description="Count fo forwarding message")
    mentions: Optional[List[StrictStr]] = Field(default=None, description="The numbers of the mentioned users")
    ad: Optional[MessageContextAD] = None
    conversion: Optional[MessageContextConversion] = None
    quoted_id: Optional[StrictStr] = Field(default=None, description="ID of quoted message")
    quoted_type: Optional[MessageType] = MessageType.TEXT
    quoted_content: Optional[MessageContent] = None
    quoted_author: Optional[StrictStr] = Field(default=None, description="Whatsapp ID of quoted message author")
    ephemeral: Optional[StrictInt] = Field(default=None, description="Ephemeral message duration")
    __properties: ClassVar[List[str]] = ["forwarded", "forwarding_score", "mentions", "ad", "conversion", "quoted_id", "quoted_type", "quoted_content", "quoted_author", "ephemeral"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of MessageContext from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of ad
        if self.ad:
            _dict['ad'] = self.ad.to_dict()
        # override the default output from pydantic by calling `to_dict()` of conversion
        if self.conversion:
            _dict['conversion'] = self.conversion.to_dict()
        # override the default output from pydantic by calling `to_dict()` of quoted_content
        if self.quoted_content:
            _dict['quoted_content'] = self.quoted_content.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of MessageContext from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "forwarded": obj.get("forwarded"),
            "forwarding_score": obj.get("forwarding_score"),
            "mentions": obj.get("mentions"),
            "ad": MessageContextAD.from_dict(obj["ad"]) if obj.get("ad") is not None else None,
            "conversion": MessageContextConversion.from_dict(obj["conversion"]) if obj.get("conversion") is not None else None,
            "quoted_id": obj.get("quoted_id"),
            "quoted_type": obj.get("quoted_type") if obj.get("quoted_type") is not None else MessageType.TEXT,
            "quoted_content": MessageContent.from_dict(obj["quoted_content"]) if obj.get("quoted_content") is not None else None,
            "quoted_author": obj.get("quoted_author"),
            "ephemeral": obj.get("ephemeral")
        })
        return _obj


