# coding: utf-8

"""
    Whapi API

    Sending and receiving messages using HTTP requests. Fixed price with no hidden fees, without limits and restrictions. You will be able to send and receive text/media/files/locations/goods/orders/polls messages via WhatsApp in private or group chats. Guides and SDK can be found on our website.

    The version of the OpenAPI document: 1.8.7
    Contact: care@whapi.cloud
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from openapi_client.models.media_message_type import MediaMessageType
from openapi_client.models.message_context_ad_source import MessageContextADSource
from typing import Optional, Set
from typing_extensions import Self

class MessageContextAD(BaseModel):
    """
    Advertisement message from META-business
    """ # noqa: E501
    advertiser_name: Optional[StrictStr] = Field(default=None, description="Name of the advertiser")
    media_type: Optional[MediaMessageType] = None
    preview: Optional[StrictStr] = Field(default=None, description="Base64 encoded preview. In JPEG format.")
    preview_url: Optional[StrictStr] = Field(default=None, description="URL of the preview")
    title: Optional[StrictStr] = Field(default=None, description="Title of the advertisement")
    body: Optional[StrictStr] = Field(default=None, description="Body of the advertisement")
    media_url: Optional[StrictStr] = Field(default=None, description="URL of the media")
    source: Optional[MessageContextADSource] = None
    auto_reply: Optional[StrictBool] = Field(default=None, description="True if the advertisement contains an auto-reply")
    attrib: Optional[StrictBool] = Field(default=None, description="True if the advertisement shows the attributions")
    ctwa: Optional[StrictStr] = Field(default=None, description="Call to action")
    ref: Optional[StrictStr] = Field(default=None, description="Reference")
    __properties: ClassVar[List[str]] = ["advertiser_name", "media_type", "preview", "preview_url", "title", "body", "media_url", "source", "auto_reply", "attrib", "ctwa", "ref"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of MessageContextAD from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of source
        if self.source:
            _dict['source'] = self.source.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of MessageContextAD from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "advertiser_name": obj.get("advertiser_name"),
            "media_type": obj.get("media_type"),
            "preview": obj.get("preview"),
            "preview_url": obj.get("preview_url"),
            "title": obj.get("title"),
            "body": obj.get("body"),
            "media_url": obj.get("media_url"),
            "source": MessageContextADSource.from_dict(obj["source"]) if obj.get("source") is not None else None,
            "auto_reply": obj.get("auto_reply"),
            "attrib": obj.get("attrib"),
            "ctwa": obj.get("ctwa"),
            "ref": obj.get("ref")
        })
        return _obj


