# coding: utf-8

"""
    Whapi API

    Sending and receiving messages using HTTP requests. Fixed price with no hidden fees, without limits and restrictions. You will be able to send and receive text/media/files/locations/goods/orders/polls messages via WhatsApp in private or group chats. Guides and SDK can be found on our website.

    The version of the OpenAPI document: 1.8.7
    Contact: care@whapi.cloud
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional, Union
from typing_extensions import Annotated
from openapi_client.models.currency import Currency
from typing import Optional, Set
from typing_extensions import Self

class ProductEdit(BaseModel):
    """
    ProductEdit
    """ # noqa: E501
    product_retailer_id: Optional[StrictStr] = Field(default=None, description="Product Retailer ID")
    currency: Optional[Currency] = None
    images: Annotated[List[StrictStr], Field(min_length=1, max_length=10)] = Field(description="Product images urls")
    availability: Optional[StrictStr] = Field(default=None, description="Product availability")
    name: Optional[StrictStr] = Field(default=None, description="Product name")
    url: Optional[StrictStr] = Field(default=None, description="Product url")
    description: Optional[StrictStr] = Field(default=None, description="Product description")
    price: Optional[Union[Annotated[float, Field(strict=True, ge=0)], Annotated[int, Field(strict=True, ge=0)]]] = Field(default=None, description="Product price")
    is_hidden: Optional[StrictBool] = Field(default=None, description="Product is hidden")
    __properties: ClassVar[List[str]] = ["product_retailer_id", "currency", "images", "availability", "name", "url", "description", "price", "is_hidden"]

    @field_validator('availability')
    def availability_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(['in stock', 'out of stock']):
            raise ValueError("must be one of enum values ('in stock', 'out of stock')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of ProductEdit from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of ProductEdit from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "product_retailer_id": obj.get("product_retailer_id"),
            "currency": obj.get("currency"),
            "images": obj.get("images"),
            "availability": obj.get("availability"),
            "name": obj.get("name"),
            "url": obj.get("url"),
            "description": obj.get("description"),
            "price": obj.get("price"),
            "is_hidden": obj.get("is_hidden")
        })
        return _obj


