# coding: utf-8

"""
    Whapi API

    Sending and receiving messages using HTTP requests. Fixed price with no hidden fees, without limits and restrictions. You will be able to send and receive text/media/files/locations/goods/orders/polls messages via WhatsApp in private or group chats. Guides and SDK can be found on our website.

    The version of the OpenAPI document: 1.8.7
    Contact: care@whapi.cloud
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class QRParameters(BaseModel):
    """
    QRParameters
    """ # noqa: E501
    size: Optional[StrictInt] = Field(default=264, description="Size of QR code")
    width: Optional[StrictInt] = Field(default=300, description="Width of QR code canvas")
    height: Optional[StrictInt] = Field(default=300, description="Height of QR code canvas")
    color_dark: Optional[StrictStr] = Field(default='#122e31', description="Color of dark pixels")
    color_light: Optional[StrictStr] = Field(default='#ffffff', description="Color of light pixels")
    __properties: ClassVar[List[str]] = ["size", "width", "height", "color_dark", "color_light"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of QRParameters from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of QRParameters from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "size": obj.get("size") if obj.get("size") is not None else 264,
            "width": obj.get("width") if obj.get("width") is not None else 300,
            "height": obj.get("height") if obj.get("height") is not None else 300,
            "color_dark": obj.get("color_dark") if obj.get("color_dark") is not None else '#122e31',
            "color_light": obj.get("color_light") if obj.get("color_light") is not None else '#ffffff'
        })
        return _obj


