# coding: utf-8

"""
    Whapi API

    Sending and receiving messages using HTTP requests. Fixed price with no hidden fees, without limits and restrictions. You will be able to send and receive text/media/files/locations/goods/orders/polls messages via WhatsApp in private or group chats. Guides and SDK can be found on our website.

    The version of the OpenAPI document: 1.8.7
    Contact: care@whapi.cloud
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictInt, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from typing_extensions import Annotated
from openapi_client.models.send_media_media import SendMediaMedia
from typing import Optional, Set
from typing_extensions import Self

class SenderStories(BaseModel):
    """
    SenderStories
    """ # noqa: E501
    media: Optional[SendMediaMedia] = None
    mime_type: Optional[StrictStr] = Field(default=None, description="Mime type of media")
    no_encode: Optional[StrictBool] = Field(default=None, description="Do not use our encoding")
    no_cache: Optional[StrictBool] = Field(default=None, description="Do not use the cache in a request")
    caption: Optional[StrictStr] = Field(default=None, description="Optional. Text caption under the media.")
    preview: Optional[StrictStr] = Field(default=None, description="Optional. Base64 encoded preview of the media. In JPEG format.")
    width: Optional[StrictInt] = Field(default=None, description="Width of the media in pixels")
    height: Optional[StrictInt] = Field(default=None, description="Height of the media in pixels")
    seconds: Optional[StrictInt] = Field(default=None, description="Optional. For audio files, this field indicates the duration of the audio file in seconds.")
    contacts: Optional[List[Annotated[str, Field(strict=True)]]] = Field(default=None, description="List of contacts to send the story to")
    background_color: Optional[Annotated[str, Field(strict=True)]] = Field(default='#00000000', description="Background color of the story (ARGB)")
    caption_color: Optional[Annotated[str, Field(strict=True)]] = Field(default='#FFFFFFFF', description="Caption color of the story (ARGB)")
    font_type: Optional[StrictStr] = Field(default=None, description="Font style of the story")
    __properties: ClassVar[List[str]] = ["media", "mime_type", "no_encode", "no_cache", "caption", "preview", "width", "height", "seconds", "contacts", "background_color", "caption_color", "font_type"]

    @field_validator('background_color')
    def background_color_validate_regular_expression(cls, value):
        """Validates the regular expression"""
        if value is None:
            return value

        if not re.match(r"^#[0-9a-fA-F]{6,8}$", value):
            raise ValueError(r"must validate the regular expression /^#[0-9a-fA-F]{6,8}$/")
        return value

    @field_validator('caption_color')
    def caption_color_validate_regular_expression(cls, value):
        """Validates the regular expression"""
        if value is None:
            return value

        if not re.match(r"^#[0-9a-fA-F]{6,8}$", value):
            raise ValueError(r"must validate the regular expression /^#[0-9a-fA-F]{6,8}$/")
        return value

    @field_validator('font_type')
    def font_type_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(['SYSTEM', 'SYSTEM_TEXT', 'FB_SCRIPT', 'SYSTEM_BOLD', 'MORNINGBREEZE_REGULAR', 'CALISTOGA_REGULAR', 'EXO2_EXTRABOLD', 'COURIERPRIME_BOLD']):
            raise ValueError("must be one of enum values ('SYSTEM', 'SYSTEM_TEXT', 'FB_SCRIPT', 'SYSTEM_BOLD', 'MORNINGBREEZE_REGULAR', 'CALISTOGA_REGULAR', 'EXO2_EXTRABOLD', 'COURIERPRIME_BOLD')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of SenderStories from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of media
        if self.media:
            _dict['media'] = self.media.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of SenderStories from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "media": SendMediaMedia.from_dict(obj["media"]) if obj.get("media") is not None else None,
            "mime_type": obj.get("mime_type"),
            "no_encode": obj.get("no_encode"),
            "no_cache": obj.get("no_cache"),
            "caption": obj.get("caption"),
            "preview": obj.get("preview"),
            "width": obj.get("width"),
            "height": obj.get("height"),
            "seconds": obj.get("seconds"),
            "contacts": obj.get("contacts"),
            "background_color": obj.get("background_color") if obj.get("background_color") is not None else '#00000000',
            "caption_color": obj.get("caption_color") if obj.get("caption_color") is not None else '#FFFFFFFF',
            "font_type": obj.get("font_type")
        })
        return _obj


