# coding: utf-8

"""
    Whapi API

    Sending and receiving messages using HTTP requests. Fixed price with no hidden fees, without limits and restrictions. You will be able to send and receive text/media/files/locations/goods/orders/polls messages via WhatsApp in private or group chats. Guides and SDK can be found on our website.

    The version of the OpenAPI document: 1.8.7
    Contact: care@whapi.cloud
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictStr
from typing import Any, ClassVar, Dict, List, Optional, Union
from typing_extensions import Annotated
from openapi_client.models.media_settings import MediaSettings
from openapi_client.models.webhook import Webhook
from typing import Optional, Set
from typing_extensions import Self

class Settings(BaseModel):
    """
    Settings
    """ # noqa: E501
    callback_backoff_delay_ms: Optional[Union[Annotated[float, Field(le=15000, strict=True, ge=3000)], Annotated[int, Field(le=15000, strict=True, ge=3000)]]] = Field(default=None, description="Backoff delay for a failed callback in milliseconds This setting is used to configure the amount of time the backoff delays before retrying a failed callback. The backoff delay increases linearly by this value each time a callback fails to get a HTTPS 200 OK response. The backoff delay is capped by the max_callback_backoff_delay_ms setting.")
    max_callback_backoff_delay_ms: Optional[Union[Annotated[float, Field(le=3600000, strict=True, ge=600000)], Annotated[int, Field(le=3600000, strict=True, ge=600000)]]] = Field(default=None, description="Maximum delay for a failed callback in milliseconds")
    callback_persist: Optional[StrictBool] = Field(default=None, description="Stores callbacks on disk until they are successfully acknowledged by the Webhook or not. Restart required.")
    media: Optional[MediaSettings] = None
    webhooks: Optional[List[Webhook]] = None
    proxy: Optional[StrictStr] = Field(default=None, description="Use your Socks5 proxy if your account activity arouses suspicion from WhatsApp. This can help maintain anonymity and ensure smooth operation.")
    mobile_proxy: Optional[StrictStr] = Field(default=None, description="Service proxy for mobile authorization.")
    offline_mode: Optional[StrictBool] = Field(default=False, description="When true, API will not send online status to the server on connection. This will allow you to receive push notifications to devices connected to the number. Working after reconnect.")
    full_history: Optional[StrictBool] = Field(default=False, description="When true, all messages will be cached after the connection. If false, old messages will selectively not be cached, allowing large accounts to run faster. Working after reconnect.")
    __properties: ClassVar[List[str]] = ["callback_backoff_delay_ms", "max_callback_backoff_delay_ms", "callback_persist", "media", "webhooks", "proxy", "mobile_proxy", "offline_mode", "full_history"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of Settings from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of media
        if self.media:
            _dict['media'] = self.media.to_dict()
        # override the default output from pydantic by calling `to_dict()` of each item in webhooks (list)
        _items = []
        if self.webhooks:
            for _item_webhooks in self.webhooks:
                if _item_webhooks:
                    _items.append(_item_webhooks.to_dict())
            _dict['webhooks'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of Settings from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "callback_backoff_delay_ms": obj.get("callback_backoff_delay_ms"),
            "max_callback_backoff_delay_ms": obj.get("max_callback_backoff_delay_ms"),
            "callback_persist": obj.get("callback_persist"),
            "media": MediaSettings.from_dict(obj["media"]) if obj.get("media") is not None else None,
            "webhooks": [Webhook.from_dict(_item) for _item in obj["webhooks"]] if obj.get("webhooks") is not None else None,
            "proxy": obj.get("proxy"),
            "mobile_proxy": obj.get("mobile_proxy"),
            "offline_mode": obj.get("offline_mode") if obj.get("offline_mode") is not None else False,
            "full_history": obj.get("full_history") if obj.get("full_history") is not None else False
        })
        return _obj


