# coding: utf-8

"""
    Whapi API

    Sending and receiving messages using HTTP requests. Fixed price with no hidden fees, without limits and restrictions. You will be able to send and receive text/media/files/locations/goods/orders/polls messages via WhatsApp in private or group chats. Guides and SDK can be found on our website.

    The version of the OpenAPI document: 1.8.7
    Contact: care@whapi.cloud
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictFloat, StrictInt, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional, Union
from typing_extensions import Annotated
from openapi_client.models.error import Error
from openapi_client.models.status_enum import StatusEnum
from typing import Optional, Set
from typing_extensions import Self

class Status(BaseModel):
    """
    
    """ # noqa: E501
    errors: Optional[List[Error]] = None
    id: StrictStr = Field(description="Message ID from event")
    code: Union[StrictFloat, StrictInt] = Field(description="Status code")
    status: StatusEnum
    recipient_id: Optional[Annotated[str, Field(strict=True)]] = Field(default=None, description="Chat ID")
    viewer_id: Optional[Annotated[str, Field(strict=True)]] = Field(default=None, description="Contact ID")
    timestamp: StrictStr = Field(description="Timestamp of the status message")
    __properties: ClassVar[List[str]] = ["errors", "id", "code", "status", "recipient_id", "viewer_id", "timestamp"]

    @field_validator('recipient_id')
    def recipient_id_validate_regular_expression(cls, value):
        """Validates the regular expression"""
        if value is None:
            return value

        if not re.match(r"^[\d-]{10,31}@[\w\.]{1,}$", value):
            raise ValueError(r"must validate the regular expression /^[\d-]{10,31}@[\w\.]{1,}$/")
        return value

    @field_validator('viewer_id')
    def viewer_id_validate_regular_expression(cls, value):
        """Validates the regular expression"""
        if value is None:
            return value

        if not re.match(r"^([\d]{7,15})?$", value):
            raise ValueError(r"must validate the regular expression /^([\d]{7,15})?$/")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of Status from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in errors (list)
        _items = []
        if self.errors:
            for _item_errors in self.errors:
                if _item_errors:
                    _items.append(_item_errors.to_dict())
            _dict['errors'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of Status from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "errors": [Error.from_dict(_item) for _item in obj["errors"]] if obj.get("errors") is not None else None,
            "id": obj.get("id"),
            "code": obj.get("code"),
            "status": obj.get("status"),
            "recipient_id": obj.get("recipient_id"),
            "viewer_id": obj.get("viewer_id"),
            "timestamp": obj.get("timestamp")
        })
        return _obj


