# coding: utf-8

"""
    Whapi API

    Sending and receiving messages using HTTP requests. Fixed price with no hidden fees, without limits and restrictions. You will be able to send and receive text/media/files/locations/goods/orders/polls messages via WhatsApp in private or group chats. Guides and SDK can be found on our website.

    The version of the OpenAPI document: 1.8.7
    Contact: care@whapi.cloud
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from openapi_client.models.event import Event
from typing import Optional, Set
from typing_extensions import Self

class Webhook(BaseModel):
    """
    Webhook
    """ # noqa: E501
    headers: Optional[Dict[str, StrictStr]] = Field(default=None, description="Additional headers for webhook. Max 5 headers. <br/>Example: <br/>\"Authorization - Bearer token\" <br/>\"Content-Type - application/json\" <br/>\"X-Header - value\"")
    url: StrictStr = Field(description="Inbound and outbound notifications are routed to this URL.")
    mode: Optional[StrictStr] = Field(default='body', description="Request method for sending hook.")
    events: Optional[List[Event]] = Field(default=None, description="Tracked events. <br/>\"messages\" - got new message/got offline messages/edit message/delete message;<br/>\"statuses\" - got message status/got offline message status;<br/>\"chats\" - got chat/chat update/chat remove;<br/>\"contacts\" - contact update;<br/>\"presences\" - got presences<br/>\"groups\" - new group/participants update/group update;<br/>\"calls\" - got call events<br/>labels\" - new label/remove label<br/>\"users\" - login user/logout user<br/>\"channel\" - instance status changed/QR-code update<br/>\"service\" - special notifications<br/><br/>\"message\", \"ack\", \"chat\", \"status\" - is deprecated, use \"messages\", \"statuses\", \"chats\", \"channel\" instead.")
    __properties: ClassVar[List[str]] = ["headers", "url", "mode", "events"]

    @field_validator('mode')
    def mode_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(['body', 'path', 'method']):
            raise ValueError("must be one of enum values ('body', 'path', 'method')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of Webhook from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in events (list)
        _items = []
        if self.events:
            for _item_events in self.events:
                if _item_events:
                    _items.append(_item_events.to_dict())
            _dict['events'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of Webhook from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "headers": obj.get("headers"),
            "url": obj.get("url"),
            "mode": obj.get("mode") if obj.get("mode") is not None else 'body',
            "events": [Event.from_dict(_item) for _item in obj["events"]] if obj.get("events") is not None else None
        })
        return _obj


