# coding: utf-8

"""
    Whapi API

    Sending and receiving messages using HTTP requests. Fixed price with no hidden fees, without limits and restrictions. You will be able to send and receive text/media/files/locations/goods/orders/polls messages via WhatsApp in private or group chats. Guides and SDK can be found on our website.

    The version of the OpenAPI document: 1.8.7
    Contact: care@whapi.cloud
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from typing_extensions import Annotated
from openapi_client.models.call_event import CallEvent
from openapi_client.models.chat import Chat
from openapi_client.models.chat_update import ChatUpdate
from openapi_client.models.contact import Contact
from openapi_client.models.contact_update import ContactUpdate
from openapi_client.models.error import Error
from openapi_client.models.event import Event
from openapi_client.models.group import Group
from openapi_client.models.group_update import GroupUpdate
from openapi_client.models.health import Health
from openapi_client.models.label import Label
from openapi_client.models.message import Message
from openapi_client.models.message_update import MessageUpdate
from openapi_client.models.participant_event import ParticipantEvent
from openapi_client.models.presence import Presence
from openapi_client.models.qr import QR
from openapi_client.models.status import Status
from typing import Optional, Set
from typing_extensions import Self

class WebhookPayload(BaseModel):
    """
    
    """ # noqa: E501
    contacts: Optional[List[Contact]] = Field(default=None, description="The contacts array contains all contacts that were sent to the webhook URL. Sent on event \"contacts.post\"")
    messages: Optional[List[Message]] = Field(default=None, description="The messages array contains all messages that were sent to the webhook URL. Sent on event \"messages.post\" or \"messages.put\"")
    messages_updates: Optional[List[MessageUpdate]] = Field(default=None, description="The messages updates array contains all messages updates that were sent to the webhook URL. Sent on event \"messages.patch\"")
    messages_removed: Optional[List[Annotated[str, Field(strict=True)]]] = Field(default=None, description="The messages removed array contains all messages removed that were sent to the webhook URL. Sent on event \"messages.delete\"")
    messages_removed_all: Optional[StrictStr] = Field(default=None, description="The messages removed all contains the chat ID of the chat that was cleared. Sent on event \"messages.delete\"")
    statuses: Optional[List[Status]] = Field(default=None, description="The messages statuses array contains all statuses that were sent to the webhook URL. Sent on event \"statuses.post\" or \"statuses.put\"")
    chats: Optional[List[Chat]] = Field(default=None, description="The chats array contains all chats that were sent to the webhook URL. Sent on event \"chats.post\" or \"chats.put\"")
    chats_updates: Optional[List[ChatUpdate]] = Field(default=None, description="The chats updates array contains all chats updates that were sent to the webhook URL. Sent on event \"chats.patch\"")
    chats_removed: Optional[List[Annotated[str, Field(strict=True)]]] = Field(default=None, description="The chats removed array contains all chats removed that were sent to the webhook URL. Sent on event \"chats.delete\"")
    contacts_updates: Optional[List[ContactUpdate]] = Field(default=None, description="The contacts updates array contains all contacts updates that were sent to the webhook URL. Sent on event \"contacts.patch\"")
    groups: Optional[List[Group]] = Field(default=None, description="The groups array contains all groups that were sent to the webhook URL. Sent on event \"groups.post\"")
    groups_participants: Optional[List[ParticipantEvent]] = Field(default=None, description="The groups participants event array contains all groups participants event that were sent to the webhook URL. Sent on event \"groups.put\"")
    groups_updates: Optional[List[GroupUpdate]] = Field(default=None, description="The groups updates array contains all groups updates that were sent to the webhook URL. Sent on event \"groups.patch\"")
    presences: Optional[List[Presence]] = Field(default=None, description="The presences array contains all presences that were sent to the webhook URL. Sent on event \"presences.post\"")
    labels: Optional[List[Label]] = Field(default=None, description="The labels array contains all labels that were sent to the webhook URL. Sent on event \"labels.post\"")
    labels_removed: Optional[List[Annotated[str, Field(strict=True)]]] = Field(default=None, description="The labels removed array contains all labels removed that were sent to the webhook URL. Sent on event \"labels.delete\"")
    calls: Optional[List[CallEvent]] = Field(default=None, description="The calls array contains all calls that were sent to the webhook URL. Sent on event \"calls.post\"")
    qr: Optional[QR] = None
    health: Optional[Health] = None
    user: Optional[Contact] = None
    errors: Optional[List[Error]] = None
    event: Optional[Event] = None
    channel_id: Optional[StrictStr] = Field(default=None, description="The channel ID")
    __properties: ClassVar[List[str]] = ["contacts", "messages", "messages_updates", "messages_removed", "messages_removed_all", "statuses", "chats", "chats_updates", "chats_removed", "contacts_updates", "groups", "groups_participants", "groups_updates", "presences", "labels", "labels_removed", "calls", "qr", "health", "user", "errors", "event", "channel_id"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of WebhookPayload from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in contacts (list)
        _items = []
        if self.contacts:
            for _item_contacts in self.contacts:
                if _item_contacts:
                    _items.append(_item_contacts.to_dict())
            _dict['contacts'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in messages (list)
        _items = []
        if self.messages:
            for _item_messages in self.messages:
                if _item_messages:
                    _items.append(_item_messages.to_dict())
            _dict['messages'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in messages_updates (list)
        _items = []
        if self.messages_updates:
            for _item_messages_updates in self.messages_updates:
                if _item_messages_updates:
                    _items.append(_item_messages_updates.to_dict())
            _dict['messages_updates'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in statuses (list)
        _items = []
        if self.statuses:
            for _item_statuses in self.statuses:
                if _item_statuses:
                    _items.append(_item_statuses.to_dict())
            _dict['statuses'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in chats (list)
        _items = []
        if self.chats:
            for _item_chats in self.chats:
                if _item_chats:
                    _items.append(_item_chats.to_dict())
            _dict['chats'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in chats_updates (list)
        _items = []
        if self.chats_updates:
            for _item_chats_updates in self.chats_updates:
                if _item_chats_updates:
                    _items.append(_item_chats_updates.to_dict())
            _dict['chats_updates'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in contacts_updates (list)
        _items = []
        if self.contacts_updates:
            for _item_contacts_updates in self.contacts_updates:
                if _item_contacts_updates:
                    _items.append(_item_contacts_updates.to_dict())
            _dict['contacts_updates'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in groups (list)
        _items = []
        if self.groups:
            for _item_groups in self.groups:
                if _item_groups:
                    _items.append(_item_groups.to_dict())
            _dict['groups'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in groups_participants (list)
        _items = []
        if self.groups_participants:
            for _item_groups_participants in self.groups_participants:
                if _item_groups_participants:
                    _items.append(_item_groups_participants.to_dict())
            _dict['groups_participants'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in groups_updates (list)
        _items = []
        if self.groups_updates:
            for _item_groups_updates in self.groups_updates:
                if _item_groups_updates:
                    _items.append(_item_groups_updates.to_dict())
            _dict['groups_updates'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in presences (list)
        _items = []
        if self.presences:
            for _item_presences in self.presences:
                if _item_presences:
                    _items.append(_item_presences.to_dict())
            _dict['presences'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in labels (list)
        _items = []
        if self.labels:
            for _item_labels in self.labels:
                if _item_labels:
                    _items.append(_item_labels.to_dict())
            _dict['labels'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in calls (list)
        _items = []
        if self.calls:
            for _item_calls in self.calls:
                if _item_calls:
                    _items.append(_item_calls.to_dict())
            _dict['calls'] = _items
        # override the default output from pydantic by calling `to_dict()` of qr
        if self.qr:
            _dict['qr'] = self.qr.to_dict()
        # override the default output from pydantic by calling `to_dict()` of health
        if self.health:
            _dict['health'] = self.health.to_dict()
        # override the default output from pydantic by calling `to_dict()` of user
        if self.user:
            _dict['user'] = self.user.to_dict()
        # override the default output from pydantic by calling `to_dict()` of each item in errors (list)
        _items = []
        if self.errors:
            for _item_errors in self.errors:
                if _item_errors:
                    _items.append(_item_errors.to_dict())
            _dict['errors'] = _items
        # override the default output from pydantic by calling `to_dict()` of event
        if self.event:
            _dict['event'] = self.event.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of WebhookPayload from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "contacts": [Contact.from_dict(_item) for _item in obj["contacts"]] if obj.get("contacts") is not None else None,
            "messages": [Message.from_dict(_item) for _item in obj["messages"]] if obj.get("messages") is not None else None,
            "messages_updates": [MessageUpdate.from_dict(_item) for _item in obj["messages_updates"]] if obj.get("messages_updates") is not None else None,
            "messages_removed": obj.get("messages_removed"),
            "messages_removed_all": obj.get("messages_removed_all"),
            "statuses": [Status.from_dict(_item) for _item in obj["statuses"]] if obj.get("statuses") is not None else None,
            "chats": [Chat.from_dict(_item) for _item in obj["chats"]] if obj.get("chats") is not None else None,
            "chats_updates": [ChatUpdate.from_dict(_item) for _item in obj["chats_updates"]] if obj.get("chats_updates") is not None else None,
            "chats_removed": obj.get("chats_removed"),
            "contacts_updates": [ContactUpdate.from_dict(_item) for _item in obj["contacts_updates"]] if obj.get("contacts_updates") is not None else None,
            "groups": [Group.from_dict(_item) for _item in obj["groups"]] if obj.get("groups") is not None else None,
            "groups_participants": [ParticipantEvent.from_dict(_item) for _item in obj["groups_participants"]] if obj.get("groups_participants") is not None else None,
            "groups_updates": [GroupUpdate.from_dict(_item) for _item in obj["groups_updates"]] if obj.get("groups_updates") is not None else None,
            "presences": [Presence.from_dict(_item) for _item in obj["presences"]] if obj.get("presences") is not None else None,
            "labels": [Label.from_dict(_item) for _item in obj["labels"]] if obj.get("labels") is not None else None,
            "labels_removed": obj.get("labels_removed"),
            "calls": [CallEvent.from_dict(_item) for _item in obj["calls"]] if obj.get("calls") is not None else None,
            "qr": QR.from_dict(obj["qr"]) if obj.get("qr") is not None else None,
            "health": Health.from_dict(obj["health"]) if obj.get("health") is not None else None,
            "user": Contact.from_dict(obj["user"]) if obj.get("user") is not None else None,
            "errors": [Error.from_dict(_item) for _item in obj["errors"]] if obj.get("errors") is not None else None,
            "event": Event.from_dict(obj["event"]) if obj.get("event") is not None else None,
            "channel_id": obj.get("channel_id")
        })
        return _obj


